<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

if (!defined("FUNC_FILE")) die("Access is limited");

class filter{
    /**
    * Array of cached bb codes
    *
    * @var array
    */
    var $cache_code = array();
    var $tags;
    var $attr;
    var $tagsm;
    var $attrm;
    var $xss;
    var $bad_tags = array('applet', 'body', 'bgsound', 'base', 'basefont', 'embed', 'frame', 'frameset', 'head', 'html', 'id', 'iframe', 'ilayer', 'layer', 'link', 'meta', 'name', 'object', 'script', 'style', 'title', 'xml');
    var $bad_attr = array('action', 'background', 'codebase', 'dynsrc', 'lowsrc');

    function init($tags=array(), $attr=array(), $tagsm=false, $attrm=false, $xss=true) {
        foreach($tags as $k => $v) $tags[$k] = strtolower($v);
        foreach($attr as $k => $v) $attr[$k] = strtolower($v);
        $this->tags = $tags;
        $this->attr = $attr;
        $this->xss = $xss;
        $this->tagsm = $tagsm;
        $this->attrm = $attrm;
    }

    function process($source) {
        if(is_array($source)) foreach($source as $k => $v) {
            if(is_string($v)) {
                //Cache bb codes
                $source = preg_replace('/\[(code|php|html|css|xml|javascript|java|cpp|delphi|python|ruby|sql)\](.+?)\[\/(code|php|html|css|xml|javascript|java|cpp|delphi|python|ruby|sql)\]/ies', "\$this->cache_code('\\2', '\\1')", $source);
                $source[$k] = $this->remove($this->decode($v));
                //Return bb codes from the cache
                $source = preg_replace('/\{cache-bbcode-([0-9]+)-([a-zA-z]+)\}/e', "\$this->set_cache('\\1', '\\2')", $source);
            }
        } else if(is_string($source)) {
            //Cache bb codes
            $source = preg_replace('/\[(code|php|html|css|xml|javascript|java|cpp|delphi|python|ruby|sql)\](.+?)\[\/(code|php|html|css|xml|javascript|java|cpp|delphi|python|ruby|sql)\]/ies', "\$this->cache_code('\\2', '\\1')", $source);
            $source = $this->remove($this->decode($source));
            //Return bb codes from the cache
            $source = preg_replace('/\{cache-bbcode-([0-9]+)-([a-zA-z]+)\}/e', "\$this->set_cache('\\1', '\\2')", $source);
        }
        return $source;
    }

    function remove($source) {

        $loopCounter=0;
        while($source != $this->filterTags($source)) {
            $source = $this->filterTags($source);
            $loopCounter++;
        }
        return $source;
    }

    function filterTags($source) {
        $pre = null;
        $post = $source;
        $tag_open = strpos($source, '<');
        while($tag_open !== false) {
            $pre .= substr($post, 0, $tag_open);
            $post = substr($post, $tag_open);
            $from_tag_open = substr($post, 1);
            $tag_end = strpos($from_tag_open, '>');
            if($tag_end === false) break;
            $tag_open_nested = strpos($from_tag_open, '<');
            if(($tag_open_nested !== false) AND ($tag_open_nested < $tag_end)) {
                $pre .= substr($post, 0, ($tag_open_nested+1));
                $post = substr($post, ($tag_open_nested+1));
                $tag_open = strpos($post, '<');
                continue;
            }
            $tag_open_nested = (strpos($from_tag_open, '<') + $tag_open + 1);
            $current_tag = substr($from_tag_open, 0, $tag_end);
            $length = strlen($current_tag);
            if(!$tag_end) {
                $pre .= $post;
                $tag_open = strpos($post, '<');
            }
            $left = $current_tag;
            $attr_set = array();
            $current_space = strpos($left, ' ');
            if(substr($current_tag, 0, 1) == "/") {
                $is_close_tag = true;
                list($tag_name) = explode(' ', $current_tag);
                $tag_name = substr($tag_name, 1);
            } else {
                $is_close_tag = false;
                list($tag_name) = explode(' ', $current_tag);
            }
            if((!preg_match("/^[a-z][a-z0-9]*$/i",$tag_name)) OR (!$tag_name) OR ((in_array(strtolower($tag_name), $this->bad_tags)) AND ($this->xss))) {
                $post = substr($post, ($length + 2));
                $tag_open = strpos($post, '<');
                continue;
            }
            while($current_space !== false) {
                $from_space = substr($left, ($current_space+1));
                $next_space = strpos($from_space, ' ');
                $open_quotes = strpos($from_space, '"');
                $close_quotes = strpos(substr($from_space, ($open_quotes+1)), '"') + $open_quotes + 1;
                if(strpos($from_space, '=') !== false) {
                    if(($open_quotes !== false) AND (strpos(substr($from_space, ($open_quotes+1)), '"') !== false)) $attr = substr($from_space, 0, ($close_quotes+1));
                    else $attr = substr($from_space, 0, $next_space);
                } else $attr = substr($from_space, 0, $next_space);
                if(!$attr) $attr = $from_space;
                $attr_set[] = $attr;
                $left = substr($from_space, strlen($attr));
                $current_space = strpos($left, ' ');
            }
            $tag_found = in_array(strtolower($tag_name), $this->tags);
            if((!$tag_found AND $this->tagsm) OR ($tag_found AND !$this->tagsm)) {
                if(!$is_close_tag) {
                    $attr_set = $this->filterAttr($attr_set);
                    $pre .= '<' . $tag_name;
                    for ($i = 0; $i < count($attr_set); $i++) $pre .= ' ' . $attr_set[$i];
                    if(strpos($from_tag_open, "</" . $tag_name)) $pre .= '>';
                    else $pre .= ' />';
                } else $pre .= '</' . $tag_name . '>';
            }

            $post = substr($post, ($length + 2));
            $tag_open = strpos($post, '<');
        }
        $pre .= $post;
        return $pre;
    }

    function filterAttr($attr_set) {
        $new_set = array();
        for ($i = 0; $i <count($attr_set); $i++) {
            if(!$attr_set[$i]) continue;
            $attr_sub_set = explode('=', trim($attr_set[$i]));
            list($attr_sub_set[0]) = explode(' ', $attr_sub_set[0]);
            if((!preg_match("/^[a-z]*$/", $attr_sub_set[0])) OR (($this->xss) AND ((in_array(strtolower($attr_sub_set[0]), $this->bad_attr)) OR (substr($attr_sub_set[0], 0, 2) == 'on')))) continue;
            if($attr_sub_set[1]) {
                $attr_sub_set[1] = str_replace('"', '', preg_replace('/\s+/', '', str_replace('&#', '', $attr_sub_set[1])));
                if((substr($attr_sub_set[1], 0, 1) == "'") AND (substr($attr_sub_set[1], (strlen($attr_sub_set[1]) - 1), 1) == "'")) $attr_sub_set[1] = substr($attr_sub_set[1], 1, (strlen($attr_sub_set[1]) - 2));
                $attr_sub_set[1] = stripslashes($attr_sub_set[1]);
            }
            if(preg_match('/javascript:|behaviour:|vbscript:|mocha:|livescript:/is', $attr_sub_set[1])) continue;
            $attr_found = in_array(strtolower($attr_sub_set[0]), $this->attr);
            if((!$attr_found AND $this->attrm) OR ($attr_found AND !$this->attrm)) {
                if($attr_sub_set[1]) $new_set[] = $attr_sub_set[0] . '="' . $attr_sub_set[1] . '"';
                else if($attr_sub_set[1] == "0") $new_set[] = $attr_sub_set[0] . '="0"';
                else $new_set[] = $attr_sub_set[0] . '="' . $attr_sub_set[0] . '"';
            }
        }
        return $new_set;
    }

    function decode($source) {
        $source = html_entity_decode($source, ENT_QUOTES, 'UTF-8');
        $source = preg_replace('/&#(\d+);/me',"chr(\\1)", $source);
        return preg_replace('/&#x([a-f0-9]+);/mei',"chr(0x\\1)", $source);
    }

    /**
    * Caching bb codes
    *
    * @param string $code
    * @param string $bb
    */
    function cache_code($code, $bb){
        $this->cache_code[] = addslashes($code);
        return "{cache-bbcode-".(count($this->cache_code)-1)."-{$bb}}";
    }

    /**
    * The function returns the bb codes from the cache
    *
    * @param string $code_id
    * @param string $bb
    */
    function set_cache($code_id, $bb){
        return '['.$bb.']'.$this->cache_code[$code_id].'[/'.$bb.']';
    }
}

//Creating an object of class
$filter = new filter;
?>