<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

if (!defined("FUNC_FILE")) die("Access is limited");

class mailman {
    /**
    * End of line sequence
    *
    * @var string
    */
    var $sep = "\r\n";
    
    /**
    * Separator attachments
    * 
    * @var string
    */
    var $bnd = "-------";
    
    /**
    * Whether attached to the letter file
    *   
    * @var bool
    */
    var $is_attache = false; 
    
    /**
    * Send mail in HTML format
    * 
    * @var bool
    */
    var $is_html = false;
    
    /**
    * Prompt notification of the receipt of mail
    * 
    * @var bool
    */
    var $receipt = false;  
    
    /**
    * Activate log posting
    * 
    * @var bool
    */
    var $log = false;
    
    /**
    * Use SMTP to send
    * 
    * @var bool
    */
    var $smtp = false;
    
    /**
    * Activate the sending of messages
    * 
    * @var bool
    */
    var $sending = true;
    
    /**
    * Severity letters
    * 
    * @var int
    */
    var $priority = 3;
    
    /**
    * Encoding messages
    * 
    * @var string
    */
    var $charset = "UTF-8";
    
    /**
    * Directory for storing eml files
    * 
    * @var string
    */
    var $path_log = 'uploads/logs/mails/';
    
    /**
    * An array of attachments
    * 
    * @var mixed
    */
    var $parts = array();
    
    /**
    * log the current message
    * 
    * @var string
    */
    var $log_txt = '';
    
    /**
    * Status of connection to the SMTP server
    * 
    * @var mixed
    */
    var $smtp_fp = false;
    
    /**
    * Message from the SMTP server when sending mail
    * 
    * @var string
    */
    var $smtp_msg = "";
    
    /**
    * SMTP server address
    * 
    * @var string
    */    
    var $smtp_host = "localhost";
    
    /**
    * SMTP server port
    * 
    * @var int
    */
    var $smtp_port = 25;
    
    /**
    * User SMTP server
    * 
    * @var string
    */
    var $smtp_user = "";
    
    /**
    * User password SMTP server
    * 
    * @var string
    */
    var $smtp_pass = "";
    
    /**
    * Response code from the SMTP server
    * 
    * @var mixed
    */
    var $smtp_code = "";
    
    /**
    * Template messages
    * 
    * @var string
    */
    var $template = '';
    
    /**
    * Site logo
    * 
    * @var string
    */
    var $logo = '';
    
    /**
    * Designer
    * 
    * @param mixed $params
    * @return mailman
    */
    function mailman($params=array()){
    global $config;
        //Create bnd length of 25 digits
        $this->bnd = rand(10000, 99999).rand(10000, 99999).rand(10000, 99999).rand(10000, 99999).rand(10000, 99999);
        $this->smtp_host = $config['smtp_host'];      //Set the host
        $this->smtp_port = $config['smtp_port'];      //Set the port
        $this->smtp_user = $config['smtp_user'];      //Set User
        $this->smtp_pass = $config['smtp_password'];  //Set password
        $this->template =  $config['template_mail'];
        $this->logo =  $config['sitelogo'];
    }
    
    /**
    * Message function
    * 
    * @param string $recipients
    * @param array $headers
    * @param string $body
    * @return bool
    */
    function send($recipients, $headers=array(), $body){
        if(!empty($this->template) AND file_exists($this->template) AND $this->is_html) 
            $body = str_replace(array('$content', '$subject', '$logo_small'), array($body, isset($headers['Subject'])?$headers['Subject']:'', "<img src='http://".get_host_name()."{$this->logo}' alt='' />"), file_get_contents($this->template));
        if(!$this->is_html) $body = str_replace("<br />", "\n", $body);
        $sets = $this->headers($headers, $body);
        $to = is_array($recipients)?implode(', ', $recipients):$recipients;
        $this->log($sets['headers'], $sets['subject'], $body);
        $body = (!$this->is_attache) ? $body : '';
        if(!$this->smtp){
            if($this->sending) $return = mail($to, $sets['subject'], $body, $sets['headers']); else $return = true;
        } else {
            if($this->sending) $return = $this->smtp_send($sets['subject'], $sets['headers'], $headers, $body); else $return = true;
        }        
        return $return;
    }
    
    /**
    * Function to create a header
    * 
    * @param array $header
    * @param string $body
    * @return array
    */
    function headers($header, $body=""){
    global $ip;
        $def_headers = array(
            'Subject'                    => '[ No subject ]',                          //​​Subject
            'Message-ID'                 => '',                                        //unique message identifier
            'Date'                       => date('r'),                                 //Date of writing letters
            'From'                       => '',                                        //Name and address of the sender
            'Sender'                     => '',                                        //sender of the letter
            'User-Agent'                 => 'Thunderbird 2.0.0.20 (Windows/20090302)', //​​client ID with which the letter was sent
            'Sender-IP'                  => $ip,                                       //​​IP address of the sender
            'X-Priority'                 => '3',                                       //Severity messages from 1 to 5
            'X-Mailer'                   => 'Nova Mailer 2',                           //​​ID of the script to send
            'MIME-Version'               => '1.0',                                     //version of MIME, which is generated message
            'To'                         => '',                                        //​​Name and address of the recipient
            'Cc'                         => '',                                        //Contains the names and addresses to which a copy is sent
            'Bcc'                        => '',                                        //​​Contains the names and addresses of recipients of letters whose addresses should not be shown to other recipients
            'Reply-To'                   => ''                                         //The name and address to which replies should be directed to this email.
            );
        foreach($def_headers as $key => $value){
            $headers[$key] = isset($header[$key]) ? (is_array($header[$key])?implode(', ', $header[$key]):$header[$key]) : $value;
            if(empty($headers[$key])) unset($headers[$key]);
        }
        
        $headers['Reply-To'] = !isset($headers['Reply-To']) ? $headers['From'] : $headers['Reply-To'];
        if($this->receipt) $headers['Return-Receipt-To'] = !isset($headers['Return-Receipt-To']) ? $headers['From'] : $headers['Return-Receipt-To'];
        $headers['Message-ID'] = !isset($headers['Message-ID']) ? "<".dechex(time()).".".time()."@".((nc_substr($_SERVER['HTTP_HOST'], 0, 4)=='www.')?str_replace("www.", "", $_SERVER['HTTP_HOST']):$_SERVER['HTTP_HOST']).">" : $headers['Message-ID'];        
        //$headers['Subject'] = "=?{$this->charset}?B?".base64_encode($headers['Subject'])."=?=";
        //$headers['From'] = "=?{$this->charset}?B?".base64_encode($headers['From'])."=?=";

        $subject = $headers['Subject']; 
        if(!$this->smtp) unset($headers['Subject']); //Remove from Subject Header as in mail() Post is transmitted separately
        
        $head = $this->text_headers($this->sanitize_headers($headers));
        if($this->is_attache){
            $attach = $this->attache2header();
            $head .= "Content-Type: multipart/mixed;{$this->sep} ".'boundary="------------'.$this->bnd.'"'.$this->sep.$this->sep.
            "This is a multi-part message in MIME format.".$this->sep."--------------".$this->bnd.$this->sep.
            "Content-Type: text/".(!$this->is_html ? "plain" : "html")."; charset={$this->charset}; format=flowed".$this->sep.
            "Content-Transfer-Encoding: 7bit".$this->sep.$this->sep.
            $body.$this->sep.$this->sep."--------------".$this->bnd.$this->sep.
            $attach."--";
        } else {
            $head .= "Content-Type: text/".(!$this->is_html ? "plain" : "html")."; charset={$this->charset}; format=flowed".$this->sep.
            "Content-Transfer-Encoding: 7bit".$this->sep;
        }
        return array("subject" => $subject, "headers" => $head);
    }
    
    /**
    * Adds files to the list of attachments.
    * 
    * @param string $file
    * @param array $conf
    * @return bool
    */        
    function add_attachment($file, $conf=array()){
    global $MIME;
        $this->is_attache = true;
        $def_conf = array(
            'isfile'      => true,
            'c_type'      => 'application/octet-stream',
            'description' => 'inline',
            'name'        => '',
        );        
        foreach($def_conf as $key => $value) $conf[$key] = !isset($conf[$key]) ? $value : $conf[$key];
        $filedata = ($conf['isfile'] === true) ? $this->file2str($file) : $file;
        if ($conf['isfile'] === true) $filename = (nc_strlen($conf['name'])) ? $conf['name'] : $file;
        else $filename = $conf['name'];
        $filename = basename($filename);
        //Define and set the MIME attachment
        $exp = get_type_file($filename);
        $conf['c_type'] = (isset($MIME[$exp])) ? $MIME[$exp] : $conf['c_type'];
        $this->parts[] = array(
            'body'        => rtrim(chunk_split(base64_encode($filedata), 72, $this->sep)),
            'name'        => $filename,
            'c_type'      => $conf['c_type'],
            'description' => "inline"
        );
        return true;
    }
    
    /**
    * Get the contents of this file as a string
    * 
    * @param string $file_name
    * @param string $cont
    * @return string
    */
    function file2str($file_name){
        if(($fd = fopen($file_name, 'rb'))){
            $filesize = nc_filesize($file_name);
            if($filesize>0){ 
                $cont = fread($fd, $filesize);
            } else $cont =  "";
            fclose($fd);
        }
        return $cont;
    }
    
    /**
    * Function to create a header file attachments
    * 
    * @return string
    */    
    function attache2header(){    
        $attache = "";
        $count = count($this->parts);
        $i=1;
        foreach($this->parts as $value){
            $headers = array(
                'Content-Type'              => "{$value['c_type']};{$this->sep} name=\"{$value['name']}\"",
                'Content-Transfer-Encoding' => 'base64',
                'Content-Disposition'       => "{$value['description']};{$this->sep} filename=\"{$value['name']}\"",
            );
            $attache .= $this->text_headers($headers).$this->sep.$value['body']."{$this->sep}--------------{$this->bnd}";
            $attache .= ($count>$i) ? $this->sep : "";
            $i++;
        }        
        return $attache;
    }

    /**
    * Function normalization title
    * 
    * @param array $headers
    * @return array
    */
    function sanitize_headers($headers){
        foreach ($headers as $key => $value) $headers[$key] = preg_replace('=((<CR>|<LF>|0x0A/%0A|0x0D/%0D|\\n|\\r)\S).*=i', null, $value);        
        return $headers;
    }
   
    /**
    * Function to create a text header
    * 
    * @param array $headers
    * @param string $return
    * @return string
    */
    function text_headers($headers, $return=''){
        foreach ($headers as $key => $value) $return .= $key.': '.$value.$this->sep;
        return $return;
    }
    
    /**
    * Logging function to send emails
    * 
    * @param string $headers
    * @param string $subject
    * @param string $body
    * @return bool
    */
    function log($headers, $subject, $body){
        if($this->log == false) return false;
        if(!$this->is_attache){
            $this->log_txt = (!$this->smtp) ? "Subject: {$subject}{$this->sep}".$headers : $headers;
            $this->log_txt .= $this->sep.$body;
        } else $this->log_txt = (!$this->smtp) ? "Subject: {$subject}{$this->sep}".$headers : $headers;
        $log_name = time().".".dechex(time()).".".rand(10000, 99999).".eml";
        $file = fopen($this->path_log.$log_name, "w");
        fputs ($file, $this->log_txt);
        fclose ($file);
        return true;
    }
    
    /**
    * Cleaning Function
    * 
    * @return void
    */
    function clear(){
        $this->parts = array();
        $this->is_attache = false;
        $this->log_txt = '';
    }
    
    /**
    * This function reads the response code from server
    * 
    * @return void
    */
    function smtp_get_line(){
        $this->smtp_msg = "";
        while(($line = fgets($this->smtp_fp, 515))){
            $this->smtp_msg .= $line;
            if(nc_substr($line, 3, 1) == " ") break;
        }
    }
    
    /**
    * Function sends the SMTP server
    * 
    * @param string $cmd
    * @return bool
    */
    function smtp_send_cmd($cmd){
        $this->smtp_msg  = "";
        $this->smtp_code = "";
        fputs($this->smtp_fp, $cmd."\r\n");
        $this->smtp_get_line();    
        $this->smtp_code = nc_substr($this->smtp_msg, 0, 3);
        return $this->smtp_code == "" ? false : true;
    }
  
    /**
    * The function sets the error SMTP server
    * 
    * @param mixed $err
    * @return bool
    */
    function smtp_error($err = ""){
        $this->smtp_msg = $err;
        return false;
    }
  
    /**
    * The function adjusts the crlf to send SMTP server
    * 
    * @param string $data
    * @return string
    */
    function smtp_crlf_encode($data){
        $data .= "\n";
        $data = str_replace("\n", "\r\n", str_replace("\r", "", $data));
        $data = str_replace("\n.\r\n" , "\n. \r\n", $data);
        return $data;
    }
    
    /**
    * Function does send a message to SMTP server.
    * 
    * @param string $subject
    * @param string $headers
    * @param array $headers_arr
    * @param string $body
    * @return bool 
    */
    function smtp_send($subject, $headers, $headers_arr, $body=""){
        //Connecting to SMTP server
        $errno = $errstr = "";
        $this->smtp_fp = @fsockopen($this->smtp_host, intval($this->smtp_port), $errno, $errstr, 30);
        if(!$this->smtp_fp){ 
            //Unable to connect to the SMTP server
            $this->smtp_error("Could not open a socket to the SMTP server");
            return false;
        }
        $this->smtp_get_line();
        $this->smtp_code = nc_substr($this->smtp_msg, 0, 3);
        if($this->smtp_code == 220){
            $data = $this->smtp_crlf_encode($headers."\n" . $body);
            $this->smtp_send_cmd("HELO ".$this->smtp_host);
            if($this->smtp_code != 250){
                $this->smtp_error("HELO");
                return false;
            }
            if(!empty($this->smtp_user) AND !empty($this->smtp_pass)){
                $this->smtp_send_cmd("AUTH LOGIN");
                if($this->smtp_code == 334){
                    $this->smtp_send_cmd(base64_encode($this->smtp_user));
                    if($this->smtp_code != 334){
                        //Username not accepted SMTP server
                        $this->smtp_error("Username not accepted from the server");
                        return false;
                    }
                    $this->smtp_send_cmd(base64_encode($this->smtp_pass));
                    if($this->smtp_code != 235){
                        //Password is not accepted SMTP server
                        $this->smtp_error("Password not accepted from the SMTP server");
                        return false;
                    }
                } else {
                    //Server does not authenticate users
                    $this->smtp_error("This SMTP server does not support authorisation");
                    return false;
                }
            }
            $this->smtp_send_cmd("MAIL FROM:".$headers_arr['From']);
            if($this->smtp_code != 250){
                //Not valid E-mail address of the sender
                $this->smtp_error("Incorrect FROM address: {$headers_arr['From']}");
                return false;
            }
            $to_arry = array($headers_arr['To']);
            foreach($to_arry as $to_email){
                $this->smtp_send_cmd("RCPT TO:".$to_email);
                if($this->smtp_code != 250){
                    $this->smtp_error("Incorrect email address: {$to_email}");
                    return false;
                    break;
                }
            }      
            $this->smtp_send_cmd("DATA");
            if($this->smtp_code == 354){
                fputs($this->smtp_fp, $data."\r\n");
            } else {
                //Error writing to the SMTP server
                $this->smtp_error("Error on write to SMTP server");
                return false;
            }      
            $this->smtp_send_cmd(".");
            if($this->smtp_code != 250){
                $this->smtp_error();
                return false;
            }      
            $this->smtp_send_cmd("quit");
            if($this->smtp_code != 221){
                $this->smtp_error();
                return false;
            }      
            @fclose($this->smtp_fp);
            return true;
        } else {
            $this->smtp_error("SMTP service unaviable");
            return false;
        }
    }
}