<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

if (!defined("FUNC_FILE")) die("Access is limited");

class main {
    /**
    * The parameter NC
    * 
    * @var bool
    */
    var $mod_rewrite = false;
    
    /**
    * Array of references
    * 
    * @var array
    */
    var $links = array();
    
    /**
    * Name of current module
    * 
    * @var string
    */
    var $module;
    
    /**
    * Title of the current module
    * 
    * @var string
    */
    var $title;
    
    /**
    * Name of the current pattern
    * 
    * @var string
    */
    var $tpl;
    
    /**
    * User Info
    * 
    * @var array
    */
    var $user;
    
    /**
    * Current location
    * 
    * @var string
    */
    var $language;
    
    /**
    * Database object
    * 
    * @var object
    */
    var $db;
    
    /**
     * Language paramentr
     * 
     * @var string
     */
    var $lang;
    
    /**
    * An array of images
    * 
    * @var array
    */
    var $img;

        /**
    * An array of images
    *
    * @var array
    */
    var $imgadmin;
    /**
    * IP address of the user
    * 
    * @var string
    */
    var $ip;
    
    /**
    * USER AGENT Users
    * 
    * @var string
    */
    var $agent;
    
    /**
    * Overall system configuration
    * 
    * @var array
    */
    var $config;
    
    /**
    * REFERER Users
    * 
    * @var string
    */
    var $ref;
    
    /**
    * REQUEST_URI Users
    * 
    * @var string
    */
    var $uri;
    
    /**
    * Site domain name
    * 
    * @var string
    */
    var $host;
    
    /**
    * Array of rules to add items
    * 
    * @var array
    */
    var $points;
    
    /**
    * Flag Identifier
    * 
    * @var bool
    */
    var $rewrite_id = true;
    
    /**
    * The class constructor
    * 
    * @return void
    */
    function main(){
    global $config;
        if($config['rewrite']==ENABLED) $this->mod_rewrite = true;
    }
    
    /**
    * Initialization of global variables
    * 
    * @return void
    */
    function init(){
    global $module_name, $userinfo, $load_tpl, $db, $lang, $module_title, $language, $img, $imgadmin, $ip, $agentinfo, $config, $points, $cross_db;
        $this->module = &$module_name;
        $this->tpl = &$load_tpl;
        $this->title = &$module_title;
        $this->user = &$userinfo;
        $this->db = &$db;
        $this->lang = &$lang;
        $this->language = &$language;
        $this->img = &$img;
        $this->imgadmin = &$imgadmin;
        $this->ip = &$ip;
        $this->agent = &$agentinfo;
        $this->config = &$config;
        $this->points = &$points;
        $referer=get_env('HTTP_REFERER');
        $this->ref = (isset($referer) ? $referer : "");
        $this->uri = get_env('REQUEST_URI');
        $this->host = get_host_name();
    }

    /**
    * Function of generation options
    * 
    * @param array $link
    * @param string $return
    * @param array $addon additional parameters (jscript links)
    * @return string
    */
    function url($link, $type_link="", $return="",$addon=array()){
    global $config, $languages2code;
        if($config['multilanguage']==ENABLED AND isset($_COOKIE['lang']) AND count($link)>0 AND isset($languages2code[$_COOKIE['lang']])) $link = array('lang' => $languages2code[$_COOKIE['lang']])+$link;
        if(count($link)==0) return 'http://'.get_host_name();
        else {
            if($this->mod_rewrite){
                foreach ($link as $kay=>$value) $return .= $config['separator_rewrite'].$value;
                $return = nc_substr($return, 1, nc_strlen($return)).$config['file_rewrite'];
            } else {
                $is_java_link = array_key_exists('jscript',$addon);
                foreach ($link as $kay=>$value) $return .= "{$kay}={$value}".($is_java_link?"&":"&amp;");
                $return = (empty($type_link)?"index.php?":"{$type_link}?").nc_substr($return, 0, ($is_java_link?nc_strlen($return)-1:nc_strlen($return)-5));
            }
        }
        $this->links[] = $return;
        return 'http://'.get_host_name().$return;
    }
    
    /**
    * Function parse the configuration NC
    * 
    * @param array $mod
    * @return void
    */
    function parse_rewrite($mod=array()){
    global $rewrite, $config, $code2languages;
        if(!isset($_GET['mod_rewrite'])){
            $this->rewrite_id = false;
            return false; 
        } else foreach($_GET as $kay=>$value) unset($kay);
        $rewrite = (empty($mod)) ? $rewrite : $mod;
        $file_type = explode($config['file_rewrite'], nc_substr(get_env('REQUEST_URI'), 1, nc_strlen(get_env('REQUEST_URI'))));
        $key_corect = 0;
        foreach($_GET as $key => $value) if($key!='mod_rewrite') unset($_GET[$key]);
        foreach (explode($config['separator_rewrite'], $file_type[0]) as $kay=>$value){
            if($config['multilanguage']==ENABLED AND isset($code2languages[$value])){
                if(!isset($_COOKIE['lang']) OR $_COOKIE['lang']!=$code2languages[$value]) setcookies($code2languages[$value], 'lang');
                $_COOKIE['lang'] = $code2languages[$value];
                $key_corect++;
                continue;
            }
            if(isset($rewrite[$kay-$key_corect])) $_GET[$rewrite[$kay-$key_corect]] = (nc_strpos($value, "%") === false) ? strip_tags($value) : strip_tags(utf8decode(urldecode($value)));
        }
        return true;
    }
}
$main = new main();

?>
