<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

if (!defined("FUNC_FILE")) die("Access is limited");

class session{
    /**
    * SESSION ID
    * 
    * @var string
    */
    var $id;
    
    /**
    * Username
    * 
    * @var string
    */
    var $login;
    
    /**
    * Time of last activity on the site
    * 
    * @var string
    */
    var $lastAction;
    
    /**
    * Time during which the user is online
    * 
    * @var int
    */
    var $maxInactiveTime;

    /**
    * Function to create a session (Designer)
    * 
    * @param string $time
    * @return session
    */
    function session($time=300){
    global $config, $db, $ip, $proxy, $agentinfo, $cache_clear_ignore;
        if(isset($_FILES["Filedata"])) return false;
        //Ignore the creation of the session for the installation of the system
        if(defined("INSTALLCMS")) return false;
        $this->maxInactiveTime = $time;
        //Define the user's IP
        if(!$this->is_session()){
            if($config['user_agent_full']!=ENABLED) $agentinfo = $this->user_agent();
            else $agentinfo = $this->user_agent_full();
            //If found cookies Users
            if(isset($_COOKIE[$config['user_cookies']])){
                $cookinfo=explode(",", $_COOKIE[$config['user_cookies']]);
                list($uid, $user_name, $user_password, $user_last_visit, $user_level, $user_baned, $user_baned_time) = $db->sql_fetchrow($db->sql_query("SELECT uid, user_name, user_password, user_last_visit, user_level, user_baned, user_baned_time FROM ".USERS." WHERE user_name='".nc_filter($cookinfo[0], TAGS)."'"));                
                //Perform user lock
                if($user_baned=="1" AND $user_baned_time>time()){
                    $this->register("Guest");
                    return false;
                }
                //Checks the data in cookies
                if(isset($cookinfo[1]) AND $user_password==$cookinfo[1]){
                    $_SESSION['lastVisit'] = (!isset($_SESSION['lastVisit'])) ? $user_last_visit : $_SESSION['lastVisit'];
                    //Register the user's session
                    $this->register($cookinfo[0]);
                    //Define the user's country
                    if($config['geoip']==ENABLED){
                        require_once "includes/function/geoip.php";
                        $gi = geoip_open("includes/GeoIP.dat", GEOIP_STANDARD);
                        $country = geoip_country_name_by_addr($gi, $ip);
                        geoip_close($gi);
                    }
                    $country = (!isset($country) OR empty($country)) ? "default" : $country;
                    //Updating user information
                    $agentinfo['os'] = (empty($agentinfo['os'])) ? "Windows" : $agentinfo['os'];
                    $agentinfo['browser'] = (empty($agentinfo['browser'])) ? "Opera" : $agentinfo['browser'];
                    $cache_clear_ignore = true;
                    $db->sql_query("UPDATE ".USERS." SET user_country='{$country}', user_last_os='".nc_filter($agentinfo['os'], TAGS)."', user_last_browser='".nc_filter($agentinfo['browser'], TAGS)."', user_last_ip='{$ip}', user_last_proxy='{$proxy}', user_last_visit='".gmdate("Y-m-d H:i:s")."' WHERE user_name='".nc_filter($user_name, TAGS)."'");
                    $cache_clear_ignore = false;
                    if($user_level>0){
                        //If the user is an admin or moderator
                        if(!isset($_SESSION['admin'])){
                            //If the administrator's session is not created
                            if(isset($_COOKIE[$config['admin_cookies']]) AND $config['logined_admin']==0){
                                //Check the data in cookies
                                $cookinfo=explode(",", $_COOKIE[$config['admin_cookies']]);
                                if ($cookinfo[1]==$user_password){
                                    $_SESSION['admin'] = $cookinfo[0];
                                    $db->sql_query("UPDATE ".SESSIONS." SET sid='".session_id()."', country='{$country}', is_admin='{$user_level}', time='".time()."' WHERE uname='{$user_name}'");                                    
                                } else {
                                    //Cookies do not pass the test, remove it so as not to interfere
                                    setcookies("", $config['admin_cookies'], 1);
                                }
                            } else setcookies("", $config['admin_cookies'], 1);
                        }
                    } else{
                        //If the session has been created and the user is not an administrator, delete the session
                        if(isset($_SESSION['admin'])) unset($_SESSION['admin']);
                    }
                } else {
                    //Cookies do not pass the test
                    // Remove it so as not to interfere
                    setcookies("", $config['user_cookies'], 1);
                    $_SESSION['lastVisit'] = 0;
                    //Register the session guest
                    $this->register("Guest");
                }
            } else $this->register("Guest");
        }
        //Obtain information about the user of the current session
        $this->userinfo();
        //Update the user's session
        $this->online();
        //Create an array of monitor users
        $this->supervision();
        return true;
    }
    
    /**
    * Function monitor users
    * 
    * @return void
    */
    function supervision(){
    global $main, $db, $supervision;
        if(!isset($_SESSION['supervision']) OR !is_array($_SESSION['supervision']) OR count($_SESSION['supervision'])<4 OR !isset($_COOKIE['update_session'])){
            //Make a selection of sessions
            $result = $db->sql_query("SELECT s.sid, s.uname, s.is_admin, s.ip, s.time, s.module, s.url, s.user_agent, s.country, u.uid, u.user_id, u.user_name, u.user_group, g.id, g.title, g.color FROM ".SESSIONS." AS s LEFT JOIN ".USERS." AS u ON(s.uname=u.user_name) LEFT JOIN ".GROUPS." AS g ON(u.user_group=g.id)");
            $online = array('admin' => array(), 'users' => array(), 'bots' => array(), 'guest' => array());
            //Sort of all users according to their types
            while(($row = $db->sql_fetchrow($result))){
                $row['url'] = str_replace("&", "&amp;", $row['url']);
                if(($row['is_admin']==1 OR $row['is_admin']==2) AND !is_ip($row['uname'])) $online['admin'][] = $row;
                elseif(!is_ip($row['uname']) AND !is_bot($row['uname'])) $online['users'][] = $row;
                elseif(is_bot($row['uname'])) $online['bots'][] = $row;
                elseif(is_ip($row['uname'])) $online['guest'][] = $row;
            }
            $_SESSION['supervision'] = $supervision = $online;
            if (!isset($_COOKIE['update_session']) AND $main->config['interval_session_update']>"0") setcookies(time() + $main->config['interval_session_update'], "update_session", time() + $main->config['interval_session_update']);
        } else $supervision = $_SESSION['supervision'];
    }
    
    /**
    * The function updates the user session
    * 
    * @return void
    */
    function online(){
    global $db, $ip, $module_name, $config, $userinfo, $list_bots;
        $user_agent = nc_filter(get_user_agent(), TAGS);
        //Disables SQL error
        $db->report_error = false;
        $user = (!is_guest()) ? $_SESSION['user'] : $ip;
        $robots = $robot_ag = "";   
        //Check whether the user is a search engine
        foreach ($list_bots as $bot_name=>$agent) if(preg_match("/$agent/i", $user_agent)){$robot_ag = $agent; $robots = $bot_name; break;}
        if(!empty($robots)){
            $user = $robots;
            $this->register($user);
            $userinfo = array('uid' => '0', 'user_id' => $robot_ag, 'user_folder'  => 'bots', 'user_name'  => $robots, 'user_email' => '', 'user_level' => 0, 'user_group' => 3, 'user_groups' => '', 'user_avatar' => 'guest.png', 'user_country' => 'default', 'group_title' => 'SearchBot');
        }
        //Check whether you need to update the session
        if(!isset($_COOKIE['update_session'])){
            //$country = (!isset($userinfo['user_country']) OR empty($userinfo['user_country'])) ? "default" : $userinfo['user_country'];
            if($config['geoip']==ENABLED){
                require_once "includes/function/geoip.php";
                $gi = geoip_open("includes/GeoIP.dat", GEOIP_STANDARD);
                $country = geoip_country_name_by_addr($gi, $ip);
                geoip_close($gi);
            }
            $country = (!isset($country) OR empty($country)) ? "default" : $country;
            $userinfo['user_country'] = $country;
            //Create or update session
            if($db->sql_fetchrow($db->sql_query("SELECT * FROM ".SESSIONS." WHERE sid='".session_id()."'"))>0) $db->sql_query("UPDATE ".SESSIONS." SET country='{$country}', is_admin='{$userinfo['user_level']}', ip='{$ip}', time='".time()."', module='{$module_name}', url='".get_env('REQUEST_URI')."' WHERE sid='".session_id()."'");                        
            else $db->sql_query("INSERT INTO ".SESSIONS." (country, is_admin, ip, sid, uname, time, module, url, user_agent) VALUES ('{$country}', '{$userinfo['user_level']}', '{$ip}', '".session_id()."', '{$user}', '".time()."', '{$module_name}', '".get_env('REQUEST_URI')."', '{$user_agent}')");
        }
        //Remove all stale session
        if(!isset($_COOKIE['online'])){ 
            if(!isset($_FILES["Filedata"])) $db->sql_query("DELETE FROM ".SESSIONS." WHERE time < '".(time() - $config['time_online'])."'");
            setcookies(time() + $config['time_online'], "online", time() + $config['time_online']);
        }
        if(!isset($_COOKIE['update_session']) AND $config['interval_session_update']>"0") setcookies(time() + $config['interval_session_update'], "update_session", time() + $config['interval_session_update']);
        //Include the error output SQL
        $db->report_error = true;
    }
    
    /**
    * The function sets the parameters of the current user session
    * 
    * @return bool
    */
    function userinfo(){
    global $userinfo, $userconf;
        if(is_guest()) {
            //If a session is created for the guest to add the needed information about the user
            $userinfo = array('uid' => '-1', 'user_id' => 'guest', 'user_folder'  => 'guest', 'user_name'  => $userconf['guest_name'], 'user_email' => '', 'user_level' => 0, 'user_group' => 4, 'user_groups' => '', 'user_avatar' => 'guest.png', 'user_country' => 'default', 'group_title' => 'Guest');
            return true;
        }
        if(!is_bot()){
            if(isset($_SESSION['cache_session_user'])){
                if($_SESSION['cache_session_user']['user_name']!=$_SESSION['user']) $_SESSION['cache_session_user'] = $this->get_userinfo_var($_SESSION['user']);
            } else $_SESSION['cache_session_user'] = $this->get_userinfo_var($_SESSION['user']);
            $userinfo = $_SESSION['cache_session_user'];
            return true;
        }
    }
    
    /**
    * Function of the sample of user data of the current session
    * 
    * @param string $name
    * @return array
    */
    function get_userinfo_var($name){
    global $db;        
        $u = $db->sql_query("SELECT * FROM ".USERS." WHERE user_name='{$name}'");
        $userinfo = $db->sql_fetchrow($u);
        $userinfo['user_folder'] = $userinfo['user_id'];
        $g = $db->sql_query("SELECT * FROM ".GROUPS." WHERE id='{$userinfo['user_group']}'");
        $group = $db->sql_fetchrow($g);        
        if(!empty($group)) {
            $group['img'] = (!empty($group['img'])) ? "<img src='includes/images/groups/{$group['img']}' alt='{$group['title']}' />" : "";
            foreach($group as $key=>$value) $userinfo['group_'.$key] = $value;
        }
    return $userinfo;
    }
    
    /**
    * The function updates the data on the browser, operating system user of the current session
    * 
    * @return void
    */
    function user_agent(){
        $agent = nc_filter(get_user_agent(), TAGS);
        if(!$agent) return $useragent = array('browser' => "undefined", 'os' => "undefined");
        //Determine the operating system user
        if(nc_strpos($agent, "Win") !== false) {
            if(nc_strpos($agent, "NT 6.0") !== false) $useragent['os'] = "Windows Vista";
            elseif(nc_strpos($agent, "NT 5.1") !== false OR nc_strpos($agent, "XP")) $useragent['os'] = "Windows XP";
            elseif(nc_strpos($agent, "NT 5.2") !== false) $useragent['os'] = "Windows Server 2003";
            elseif(nc_strpos($agent, "NT 5.0") !== false) $useragent['os'] = 'Windows 2000';
            elseif(nc_strpos($agent, "NT 4.0") !== false OR nc_strpos($agent, "3.5") !== false) $useragent['os'] = "Windows NT";
            elseif(nc_strpos($agent, "Me") !== false) $useragent['os'] = "Windows Me";
            elseif(nc_strpos($agent, "98") !== false) $useragent['os'] = "Windows 98";
            elseif(nc_strpos($agent, "95") !== false) $useragent['os'] = "Windows 95";
        }
        elseif(nc_strpos($agent, "Linux") !== false OR nc_strpos($agent, "Lynx")!== false OR nc_strpos($agent, "Unix")!== false) $useragent['os'] = "Linux";
        elseif(nc_strpos($agent, "Macintosh") !== false OR nc_strpos($agent, "PowerPC")) $useragent['os'] = "Macintosh";
        elseif(nc_strpos($agent, "FreeBSD") !== false) $useragent['os'] = "FreeBSD";
        else $useragent['os'] = "undefined";    

        //Define the user's browser
        if(nc_strpos($agent, "Maxthon") !== false) $useragent['browser'] = "Maxthon";
        elseif(nc_strpos($agent, "MSIE") !== false) $useragent['browser'] = "Internet Explorer";
        elseif(nc_strpos($agent, "Firefox") !== false) $useragent['browser'] = "Firefox";
        elseif(nc_strpos($agent, "Opera") !== false) $useragent['browser'] = "Opera";
        elseif(nc_strpos($agent, "Netscape") !== false) $useragent['browser'] = "Netscape";
        elseif(nc_strpos($agent, "Safari") !== false AND nc_strpos($agent, "Chrome") === false) $useragent['browser'] = "Safari";
        elseif(nc_strpos($agent, "Chrome") !== false) $useragent['browser'] = "Chrome";
        else $useragent['browser'] =  "undefined";
        return $useragent;
    } 
    
    function user_agent_full(){
    global $list_browser, $list_os;
        require_once 'includes/config/user_agents.php';
        $agent = nc_filter(get_user_agent(), TAGS);
        $useragent = array('browser' => "undefined", 'os' => "undefined");
        if(!$agent) return $useragent;
        //Define the user's browser
        $agent = nc_strtolower($agent);    
        foreach ($list_browser as $key => $value) {
            if(nc_strpos($agent, $key) !== false)  {
                if(is_array($value)) { 
                	$mathes = "";
                    if(preg_match($value[1], $agent, $mathes)) {
                        $useragent['browser'] = $value[0].' '.(isset($mathes[1])?$mathes[1]:'');
                        break;
                    }
                } else {
                    $useragent['browser'] = $value;
                    break;
                }  
            }   
        }
        //Determine the operating system user
        $agent = str_replace(' ', '', $agent);
        foreach ($list_os as $key => $value) {
            if(nc_strpos($agent, $key) !== false)  {
                if(is_array($value)) {
                    foreach ($value as $mask  => $os) {
                        if(nc_strpos($agent, $mask) !== false) {
                            $useragent['os'] = $os; 
                            break;
                        }
                    }
                } else {
                    $useragent['os'] = $value; 
                    break;
                }  
            }   
        }
        return $useragent;
    }    

    /**
    * The function registers the user's session
    * 
    * @param mixed $login
    * @return void
    */
    function register($login){
    global $userconf;
        //Set the session identifier
        $this->id = session_id();
        //Set the username for which the open session
        $this->login = ($login!="Guest") ? $login : $userconf['guest_name'];
        //Set the time of the last user activity
        $this->lastAction = time();
        //Set the session ID in $ _SESSION
        $_SESSION['id']    = $this->get_session_id();
        //Set the username for which the opening of the session $ _SESSION
        $_SESSION['user'] = $this->get_user();
        //Set during the last activity of the user in $ _SESSION
        $_SESSION['lastAction']    = time();
    }

    /**
    * Function checks whether the user's session is open
    * 
    * @return bool
    */
    function is_session(){
        if(!isset($_SESSION['id']) OR !isset($_SESSION['user'])){return false;}
        if(!$this->is_inativo($_SESSION['lastAction'])){return false;}
        return true;
    }

    /**
    * Function checks whether the session has expired
    * 
    * @param string $lastAction
    * @return bool
    */
    function is_inativo($lastAction){
        if((time() - $lastAction) >= $this->maxInactiveTime){
            return false;
        } else {
            $_SESSION['lastAction'] = time();
            return true;
        }
    }
    
    /**
    * The delete function session
    * 
    * @return void
    */
    function kill_session_cache(){
        //Remove user data
        if(isset($_SESSION['cache_session_user'])) unset($_SESSION['cache_session_user']);
        //Remove the session with a user name
        if(isset($_SESSION['user'])) unset($_SESSION['user']);
        //Remove session ID
        if(isset($_SESSION['id'])) unset($_SESSION['id']);
        //Remove the session from the last user action
        if(isset($_SESSION['lastAction'])) unset($_SESSION['lastAction']);
        //Delete cookies update session
        setcookies("", 'update_session', 1);        
        //Delete cookies updating user information
        setcookies("", 'online', 1);
    }

    /**
    * The function destroys all data registered in the session.
    * 
    * @return void
    */
    function destroy_session(){session_destroy();}
    
    /**
    * The function returns the session ID
    * 
    * @return string
    */
    function get_session_id(){return $this->id;}
    
    /**
    * The function returns the user login
    * 
    * @return string
    */
    function get_user(){return $this->login;}
    
    /**
    * The function returns the time during which the user is online
    * 
    * @return string
    */
    function get_max_seesion_time(){return $this->maxInactiveTime;}
    
    /**
    * The function returns the last user's actions on the site.
    * 
    * @return string
    */
    function get_last_action(){return $this->lastAction;}
}
?>