<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

   if (!defined('FUNC_FILE')) die('Access is limited');

   class treedb {
      /**
      * Handle tables
      * 
      * @var string
      */
      var $table = "";
      var $count_char_in_level=2;
      var $pack_db_after_remove=TRUE;
      var $code_num_db=36;// basis for coding the number into the database

      /**
      * Designer
      * 
      * @param string $table
      * @return treedb
      */
      function treedb($table,$count_char_level=2){
         $this->table = $table;
         $this->count_char_in_level=$count_char_level;
      }
      function get_one_value($sql){
         global $main;
         $result = $main->db->sql_query($sql);
         $row = $main->db->sql_fetchrow($result);
         return $row[0];
      }
      /**
      * Getting a new (to the maximum znyacheniya. tree
      * 
      * @param string $parent
      * @return string
      */
      function get_max_id($parent){
         global $main;
         $s_zero = "0000000000"; $space = '';
         $code_num = $this->code_num_db;
         for($i=1;$i<=$this->count_char_in_level;$i++) $space .= '_';
         $scase="when 0 then ''";
         $zero_id='1';
         for($i=1;$i<$this->count_char_in_level;$i++){;
            $lzero=nc_substr($s_zero,1,$this->count_char_in_level-$i);
            $scase.="\n when ".$i." then '{$lzero}'";
            $zero_id="0".$zero_id;
         }
         $result = $main->db->sql_query("select if(isnull(max(t.tree)),'{$parent}{$zero_id}',\n".
         "concat(case mod(LenGth(conv(conv(max(t.tree),{$code_num},10)+1,10,{$code_num})),{$this->count_char_in_level})\n{$scase}\n".
         "end,conv(conv(max(t.tree),{$code_num},10)+1,10,{$code_num}))) newid\n".
         "from  {$this->table} t \n".
         "where t.tree LIKE '{$parent}{$space}'");
         $row = $main->db->sql_fetchrow($result);         
         return $row['newid'];
      }
      /**
      * Adding branches of a tree
      * 
      * @param string $parent
      * @param string $sql_insert
      * @return string
      */
      function append($parent, $sql_insert){
         global $main;
         $id = $this->get_max_id($parent);         
         $main->db->sql_query(preg_replace('/\{IDTREE\}/i', $id, $sql_insert));
         return $id;
      }
      /**
      * Upward shift of the field tree after the move, and delete operations
      * 
      * @param string $parent
      */
      function pack_after($parent){
         global $main;
         if ($this->pack_db_after_remove) {
            $new_like = nc_substr($parent,0,nc_strlen($parent)-$this->count_char_in_level);
            $sql="update {$this->table} t \nset t.tree=".$this->get_concat_param($parent,FALSE)."\n".
            "where t.tree like '{$new_like}%' and t.tree>'{$parent}' ";
            $main->db->sql_query($sql);
         }
      }
      /**
      * Removing a tree branch
      * 
      * @param mixed $parent
      * @return boolean
      */
      function delete($parent){
         global $main;
         $main->db->sql_query("DELETE FROM {$this->table} WHERE tree LIKE '{$parent}%'");
         $result=$main->db->sql_affectedrows();
         $this->pack_after($parent);
         return $result!=0;
      }
      /**
      * concat returns a row for the shifts of the branches on a tree
      * 
      * @param string $parent (branch from which the shift)
      * @param boolean $down_shift( shift down?)
      */
      function get_concat_param($parent,$down_shift){
         $s_zero="0000000000";
         $code_num=$this->code_num_db;
         $lenparent=nc_strlen($parent);
         $level=$this->count_char_in_level;  
         $scase="when 0 then ''";
         for($i=1;$i<$level;$i++){;
            $lzero=nc_substr($s_zero,1,$level-$i);
            $scase.="\nwhen {$i} then '{$lzero}'";
         }
         return  "concat(case mod(length(conv(conv(substring(t.tree,1,{$lenparent}),{$code_num},10)".($down_shift?"+":"-")."1,10,{$code_num})),{$level})\n".
         "{$scase} \n".
         "end ,conv(conv(substring(t.tree,1,{$lenparent}),{$code_num},10)".($down_shift?"+":"-")."1,10,{$code_num}),substring(t.tree,".++$lenparent.",LenGth(t.tree)-{$level}))";
      }
      /**
      * Insert the branch before the specified element
      * 
      * @param string $parent
      * @param string $sql_insert
      * @return void
      */
      function insert_before($parent, $sql_insert){
         global $main;
         $code_num = $this->code_num_db;
         $new_like = nc_substr($parent,0,nc_strlen($parent)-$this->count_char_in_level);
         $sql="update {$this->table} t \nset t.tree=".$this->get_concat_param($parent,TRUE)."\n".
         "where t.tree like '{$new_like}%' and t.tree>='{$parent}'";
         $main->db->sql_query($sql);
         $main->db->sql_query(preg_replace('/\{IDTREE\}/i', $parent, $sql_insert));
      }
      /**
      * Insert the branch after a given element
      * 
      * @param string $parent
      * @param string $sql_insert
      * @return void
      */
      function insert_after($parent, $sql_insert){
         global $main;
         $s_zero="0000000000";
         $code_num=$this->code_num_db;
         $level=$this->count_char_in_level;  
         $new_like = nc_substr($parent,0,nc_strlen($parent)-$level);
         $sql="update {$this->table} t \nset t.tree=".$this->get_concat_param($parent,TRUE)."\n".
         "where t.tree like '".$new_like."%' and t.tree>'".$parent."' and not(t.tree like '".$parent."%')";
         $main->db->sql_query($sql);
         $new_id=base_convert(base_convert($parent,$code_num,10)+1,10,$code_num);
         $n=$level-(nc_strlen($new_id) % $level);
         $new_id=nc_substr($s_zero,1,$n).$new_id;
         $main->db->sql_query(preg_replace('/\{IDTREE\}/i',$new_id , $sql_insert));
      }
      /**
      * checking for the existence of branches of a tree with a given code
      * 
      * @param string $parent (code branches to find)
      * @return void 
      */
      function exists_tree($parent){
         global $main;
         $sql="select t.tree from {$this->table} t where t.tree='{$parent}'";
         $result = $main->db->sql_query($sql);
         $row = $main->db->sql_fetchrow($result);
         return !empty($row['tree']);
      }
      /**
      * Move to the end of the branches of a tree $ dest
      * 
      * @param string $sourse
      * @param string $dest
      * @return void
      */
      function move($sourse, $dest){
         global $main;         
         if ($this->exists_tree($dest) or $dest=="") {
            $len_source=nc_strlen($sourse);
            $new_id=$this->get_max_id($dest);
            $sql="update {$this->table} t \n".
            "set t.tree=concat('{$new_id}',substring(t.tree,".($len_source+1).",length(t.tree)-{$len_source})) \n".
            "where t.tree like '{$sourse}%'";
            $main->db->sql_query($sql);
            $this->pack_after($sourse);
         } 
      }
      /**
      * Moving branches of the tree
      * 
      * @param string $sourse
      * @param string $dest
      * @return void
      */
      function replace($sourse, $dest){
         global $main;
         if ($this->exists_tree($dest)  and $this->exists_tree($sourse)){ 
            $main->db->sql_query("update {$this->table} t set t.tree=concat('ZZ',substring(t.tree,".(nc_strlen($dest)+1).",length(t.tree)-".(nc_strlen($dest)).")) where t.tree like '{$dest}%'");
            $main->db->sql_query("update {$this->table} t set t.tree=concat('{$dest}',substring(t.tree,".(nc_strlen($sourse)+1).",length(t.tree)-".(nc_strlen($sourse)).")) where t.tree like '{$sourse}%'");
            $main->db->sql_query("update {$this->table} t set t.tree=concat('{$sourse}',substring(t.tree,3,length(t.tree)-2)) where t.tree like 'ZZ%'");
            return TRUE;
         } else return FALSE;  
      }
      /**
      * Conversion of $id in database format
      * 
      * @param mixed $id
      */
      function conv_id($id){
         $strh='0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
         $ret="";$mid=$id;
         while ($mid>=$this->code_num_db){
            $num=$mid % $this->code_num_db;
            $mid=($mid-$num)/$this->code_num_db;
            $ret=$strh[$num].$ret;
         }
         $ret=$strh[$mid].$ret;
         while (strlen($ret)<$this->count_char_in_level) $ret="0".$ret;
         return $ret;
      }
      /**
      * Sorts the children of the branch
      * 
      * @param string $source
      * @param string $sort_where
      */
      function sort_item($source,$sort_order){
         global $main;
         $subs="_______________________";
         $like=substr($subs,0,$this->count_char_in_level);
         $res=$main->db->sql_query("select * from ".$this->table." where tree like '{$source}{$like}' ".$sort_order);
         $i=0;
         while ($row=$main->db->sql_fetchrow($res)){
            $i++;$new_id=$source.$this->conv_id($i);
            $curr=$this->get_one_value("select `tree` from ".$this->table." where id={$row['id']}");
            if ($curr!=$new_id) {
            $this->replace($curr,$new_id);
            }
         }
      }
   }

?>
