<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

if (!defined("FUNC_FILE")) die("Access is limited");

class upload {
    /**
    * The name of the downloaded file
    * 
    * @var string
    */
    var $file;
    
    /**
    * Flag of errors loading
    * 
    * @var mbool
    */
    var $error = false;
    
    /**
    * Overwrite files with the same name
    * 
    * @var bool
    */
    var $overwrite = false;
    
    /**
    * Error message
    * 
    * @var string
    */
    var $error_msg;
    
    /**
    * Error Code
    * 
    * @var int
    */
    var $error_number;
        
    /**
    * Type of uploaded file
    *     
    * @var string
    */
    var $expansion;
    
    /**
    * Flag of the download
    * 
    * @var bool
    */
    var $is_upload = false;

    /**
    * Designer
    * 
    * @param array $atrib
    * @return upload
    */
    function upload($atrib){
        /*
        $atrib = array(
            'dir'         => 'uploads/',                              //Download directory
            'file'        => $_FILES['userfile'],                     //Download file
            ['size'       => 1024,]                                   //Maximum upload file size (Kb)
            ['type'       => array('gif', 'png', 'jpg', 'jpeg'),]     //Valid permit downloads
            ['width'      => 800,]                                    //Maximum width of loaded image (px)
            ['height'     => 600,]                                    //Maximum height of loaded image (px)
            ['name'       => 'new_file_name',]                        //New name for the uploaded file
            ['overwrite'] => false]                                   //Parameter is responsible for overwriting files
        );
        */
        if(isset($atrib['overwrite'])) $this->overwrite = $atrib['overwrite'];
        $this->set_error($this->upload_file($atrib));
    }

    /**
    * Download files
    * 
    * @param array $atrib
    * @return int
    */
    function upload_file($atrib){
        $atrib['size'] = $atrib['size'] * 1024;
        if(isset($atrib['file'])){            
            //Define a new file name
            $this->file = cyr2lat(!isset($atrib['name']) ? $atrib['file']['name'] : $atrib['name'].".".$this->get_expansion($atrib['file']['name']));
            //Check whether we have the right to overwrite the file
            if(!$this->overwrite AND nc_file_exists($atrib['dir'].$this->file)) return 1;
            $atrib['tmp_name'] = $atrib['file']['tmp_name'];
            if(is_uploaded_file($atrib['tmp_name']) AND $atrib['tmp_name']["size"]){                
                //Returns the type of downloaded file
                $this->expansion = $this->get_expansion($atrib['file']['name']);
                //Checking the downloaded file
                if(isset($atrib['size']) AND $atrib['size'] > $atrib['size']) return 2;
                elseif(isset($atrib['type']) AND !in_array(nc_strtoupper($this->expansion), $atrib['type']) AND !in_array(nc_strtolower($this->expansion), $atrib['type'])) return 3;                
                //Perform file copy
                //if(!copy($atrib['tmp_name'], $atrib['dir'].$this->file)) return 5;
                if(!move_uploaded_file($atrib['tmp_name'], $atrib['dir'].$this->file)) return 5;
                //If you load the image, then check it pixel value
                if(nc_strpos($atrib['file']['type'], 'image')!==false AND isset($atrib['width']) AND isset($atrib['height'])){
                    $size_image = getimagesize($atrib['dir'].$this->file);
                    if($size_image[0] > $atrib['width'] OR $size_image[1] > $atrib['height']){
                        nc_unlink($atrib['dir'].$this->file);
                        return 4;
                    }
                } 
                $this->is_upload = true;
            } else return 5;
        }
        return 0;
    }

    /**
    * Function definition error
    * 
    * @param int $int
    * @return void
    */
    function set_error($int){
    global $lang;
        $this->error = ($int>0) ? true : false;
        $this->error_number = $int;
        switch($int){
            case 1: $this->error_msg = $lang['upload_file_exists']; break;   //File with that name already loaded!
            case 2: $this->error_msg = $lang['upload_file_size']; break;     //Privyshen allowable file size!
            case 3: $this->error_msg = $lang['upload_file_type']; break;     //Invalid File Format!
            case 4: $this->error_msg = $lang['upload_file_image']; break;    //Privyshen allowable size image!
            case 5: $this->error_msg = $lang['upload_file_error']; break;    //Error downloading file!
        }
    }

    /**
    * The function returns the type of uploaded file
    * 
    * @param string $file
    * @return string
    */
    function get_expansion($file){
        return preg_replace('/(.+?)[.]([a-zA-z0-9]+)$/', '\\2', $file);
    }

    /**
    * The function returns an error when loading file
    * 
    * @return int
    */
    function get_error(){
        return $this->error_number;
    }

    /**
    * The function returns the error when loading file
    * 
    * @return string
    */
    function get_error_msg(){
        return $this->error_msg;
    }
}
?>