<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

if (!defined('FUNC_FILE')) die('Access is limited'); 

$list_browser = array(  
    'abrowse'                => array('ABrowse'         , '/abrowse\s([0-9]{1}\.[0-9]{1}([0-9])?)/'),
    'acoo browser'           =>       'Acoo',
    'amaya'                  => array('Amaya'           , '/amaya\/([0-9]{1,2}(\.[0-9]{1,3})?)/'),
    'america online browser' => array('America Online'  , '/america online browser[\s]([0-9]{1}\.[0-9]{1}([0-9])?)/'),
    'amigavoyager'           => array('Amiga Voyager'   , '/amigavoyager\/([0-9]{1}\.[0-9]{1}([0-9])?)/'),
    'amiga-aweb'             => array('Amiga AWeb'      , '/amiga-aweb\/([0-9]{1}\.[0-9]{1}([0-9]{1,3})?)/'),
    'arora'                  => array('Arora'           , '/arora\/([0-9]{1}\.[0-9]{1})/'),
    'beonex'                 => array('Beonex'          , '/beonex\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'bolt'                   => array('Bolt'            , '/bolt\/([0-9]{1}(\.[0-9]{1,3})?)/'),
    'bonecho'                => array('BonEcho'         , '/bonecho\/([0-9]{1}\.[0-9]{1}(\.[0-9])?(\.[0-9])?)/'),
    'camino'                 => array('Camino'          , '/camino\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'cheshire'               => array('Cheshire'        , '/cheshire\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'chimera'                => array('Chimera'         , '/chimera\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'chrome'                 => array('Chrome'          , '/chrome\/([^\s]+)/'),
    'chrome'                 =>       'Chrome',
    'cometbird'              => array('CometBird'       , '/cometbird\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'crazy browser'          => array('Crazy'           , '/crazy browser\s([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'cyberdog'               => array('Cyberdog'        , '/cyberdog\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'deepnet explorer'       => array('Deepnet Explorer', '/deepnet explorer\s([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'demeter'                => array('Demeter'         , '/demeter\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'dillo'                  => array('Dillo'           , '/dillo\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'doczilla'               => array('DocZilla'        , '/doczilla\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'doris'                  => array('Doris'           , '/doris\/([0-9]{1}\.[0-9]{1,3}(\.[0-9])?)/'),
    'elinks'                 => array('Chrome'          , '/elinks\/([0-9]{1}\.[0-9]{1,2}(\.[0-9])?)/'),
    'elinks'                 => array('Elinks'          , '/elinks\s\(([0-9]{1}\.[0-9]{1,2}(\.[0-9])?)/'),
    'enigma browser'         =>       'Enigma',
    'epiphany'               => array('Epiphany'        , '/epiphany\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'epiphany'               =>       'Epiphany',
    'fennec'                 => array('Fennec'          , '/fennec\/([0-9]{1}\.[0-9]{1}([0-9])?)/'),
    'firebird'               => array('Firebird'        , '/firebird\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'flock'                  => array('Flock'           , '/flock\/([0-9]{1}\.[0-9]{1}(\.[0-9]{1,2})?(\.[0-9]{1,2})?(\.[0-9]{1})?)/'),
    'fluid'                  => array('Fluid'           , '/fluid\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'galaxy'                 => array('Galaxy'          , '/galaxy\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'galeon'                 => array('Galeon'          , '/galeon\/([0-9]{1}\.[0-9]{1}(\.[0-9]{1,2})?)/'),
    'granparadiso'           => array('GranParadiso'    , '/granparadiso\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'gosurf'                 =>       'GoSuRF',
    'greenbrowser'           =>       'Green Browser',
    'hana'                   => array('Hana'            , '/hana\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'hotjava'                => array('HotJava'         , '/hotjava\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'hv3'                    =>       'Hv3',
    'ibrowse'                => array('IBrowse'         , '/ibrowse\s([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'icab'                   => array('iCab'            , '/icab[\/\s]([0-9]{1}(\.[0-9]{1})?(\.[0-9])?)/'),
    'iceape'                 => array('Iceape'          , '/iceape\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'icecat'                 => array('IceCat'          , '/icecat\/([0-9]{1}\.[0-9]{1}(\.[0-9])?(\.[0-9]{1,2})?(\.[0-9]{1,2})?)/'),
    'iceweasel'              => array('Iceweasel'       , '/iceweasel\/([0-9]{1}\.[0-9]{1}(\.[0-9])?(\.[0-9]{1,2})?(\.[0-9]{1,2})?)/'),
    'irider'                 => array('iRider'          , '/irider\s([0-9]{1}\.[0-9]{1,3}(\.[0-9]{1,4})?)/'),
    'iron'                   => array('Iron'            , '/iron\/([0-9]{1}\.[0-9]{1}(\.[0-9]{1,3})?(\.[0-9]{1})?)/'),
    'k-meleon'               => array('K-Meleon'        , '/k-meleon[\/\s]([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'kmlite'                 => array('K-Meleon Lite'   , '/kmlite\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'k-ninja'                => array('K-Ninja'         , '/k-ninja[\/\s]([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'kapiko'                 => array('Kapiko'          , '/kapiko\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'kazehakase'             => array('Kazehakase'      , '/kazehakase\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'kkman'                  => array('KKman'           , '/kkman([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'konqueror'              => array('Konqueror'       , '/konqueror\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'links'                  => array('Links'           , '/links\s\(([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'lobo'                   => array('Lobo'            , '/lobo\/([0-9]{1}\.[0-9]{1,2}(\.[0-9])?)/'),
    'lolifox'                => array('Lolifox'         , '/lolifox\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'lotus-notes'            => array('Lotus-Notes'     , '/lotus-notes\/([0-9]{1}\.[0-9]{1,2}(\.[0-9])?)/'),
    'lunascape'              => array('Lunascape'       , '/lunascape[\/\s]([0-9]{1}\.[0-9]{1}(\.[0-9]{1})?(\.[0-9]{1,3})?)/'),
    'lynx'                   => array('Lynx'            , '/lynx\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'lynx'                   =>       'Lynx',
    'midori'                 => array('Midori'          , '/midori\/([0-9]{1}\.[0-9]{1,2}(\.[0-9]{1,2})?)/'),  
    'midori'                 =>       'Midori',  
    'minefield'              => array('Minefield'       , '/minefield\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),  
    'minimo'                 => array('Minimo'          , '/minimo\/([0-9]{1}\.[0-9]{1,3})/'),  
    'mnenhy'                 => array('Mnenhy'          , '/mnenhy\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),  
    'multizilla'             => array('MultiZilla'      , '/multizilla[\/\s]v?([0-9]{1}\.[0-9]{1}(\.[0-9]{1,2})?(\.[0-9]{1,2})?)/'),  
    'nautilus'               => array('Nautilus'        , '/nautilus\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'ncsa_mosaic'            => array('NCSA Mosaic'     , '/ncsa_mosaic\/([0-9]{1}\.[0-9]{1})/'),
    'netbox'                 => array('Net Box'         , '/netbox\/([0-9]{1}\.[0-9]{1,2}(\.[0-9])?)/'),
    'netcaptor'              => array('NetCaptor'       , '/netcaptor\s([0-9]{1}\.[0-9]{1,2}(\.[0-9])?)/'),
    'netnewswire'            => array('NetNewsWire'     , '/netnewswire\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'netsurf'                => array('NetSurf'         , '/netsurf\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'offbyone'               =>       'Off By One',
    'omniweb'                => array('OmniWeb'         , '/omniweb\/v?([0-9]{1,3}(\.[0-9]{1,2})?(\.[0-9])?(\.[0-9])?(\.[0-9]{1,6})?)/'),  
    'opera'                  => array('Opera'           , '/version[\/\s]([0-9]{1,2}\.[0-9]{1}([0-9])?)/'),
    'orca'                   => array('Orca'            , '/orca\/([0-9]{1,2}\.[0-9]{1}([0-9])?)/'),
    'oregano'                => array('Oregano'         , '/oregano\s([0-9]{1}\.[0-9]{1}([0-9])?)/'),
    'phaseout'               =>       'Phaseout',
    'pogo'                   =>       'Pogo',
    'phoenix'                => array('Phoenix'         , '/phoenix\/([0-9]{1}\.[0-9]{1}([0-9])?)/'),
    'qtweb'                  => array('QtWeb'           , '/qtweb internet browser\/([0-9]{1}\.[0-9]{1}([0-9])?)/'),
    'seamonkey'              => array('SeaMonkey'       , '/seamonkey[\/\-]([0-9]{1}\.[0-9]{1}(\.[0-9]{1,2})?)/'),
    'shiira'                 => array('Shiira'          , '/shiira\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'shiira'                 =>       'Shiira',
    'slimbrowser'            =>       'Slim Browser',
    'shiretoko'              => array('Shiretoko'       , '/shiretoko\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'sleipnir'               => array('Sleipnir'        , '/sleipnir[\/\s]([0-9]{1}\.[0-9]{1,2}(\.[0-9]{1,2})?)/'),
    'stainless'              => array('Stainless'       , '/stainless\/([0-9]{1}\.[0-9]{1}(\.[0-9]{1})?)/'),
    'sunrise'                => array('Sunrise'         , '/sunrise\/([0-9]{1}\.[0-9]{1}(\.[0-9]{1})?)/'),
    'sunrise'                => array('Sunrise'         , '/sunrisebrowser\/([0-9]{1}\.[0-9]{1,3})/'),
    'swiftfox'               =>       'Swiftfox',
    'swiftweasel'            =>       'Swiftweasel',
    'swift'                  =>       'Swift',
    'w3m'                    => array('w3m'             , '/w3m\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'fasterfox'              =>       'Fasterfox',  
    'firefox'                => array('Firefox'         , '/firefox\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'mozilla'                => array('Mozilla'         , '/ rv:([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'avant browser'          => array('Gogo Explorer'   , '/gogo explorer\s([0-9]{1})/'),
    'avant browser'          => array('Avant'           , '/maxthon\s([0-9]{1}\.[0-9]{1})/'),
    'avant browser'          =>       'Avant',
    'maxthon'                => array('Maxthon'         , '/maxthon\s([0-9]{1}\.[0-9]{1})/'),
    'maxthon'                =>       'Maxthon',
    'myie2'                  =>       'MyIE2',  
    'netscape'               => array('Netscape'        , '/netscape\/([0-9]{1}\.[0-9]{1}(\.[0-9])?)/'),
    'safari'                 => array('Safari'          , '/safari\/([0-9]{2,3}(\.[0-9])?)/'),
    'msie'                   => array('AOL'             , '/aol\s([0-9]{1}\.[0-9]{1})/'),
    'msie'                   => array('Internet Explorer', '/msie\s([0-9]{1}\.[0-9]{1,2})/')  
);

$list_os = array( 
    'win' => array( 
        'windowsnt6.1'  => 'Windows 7',
        'windowsnt6.0'  => 'Windows Vista',
        'windowsnt5.2'  => 'Windows 2003 server',
        'windowsnt5.1'  => 'Windows XP',
        'windowsxp'     => 'Windows XP',
        'windowsnt5.0'  => 'Windows 2000',
        'windowsnt'     => 'Windows NT',
        'windows98'     => 'Windows 98',
        'wince'         => 'Windows CE',
        'win9x4.90'     => 'Windows ME',
        'winme'         => 'Windows ME'
    ),
    'linux' => array( 
        'alinux'        => 'aLinux',
        'absolute'      => 'Absolute Linux',
        'adamantix'     => 'Adamantix Linux',
        'adios'         => 'Adios Linux',
        'alinex'        => 'Alinex Linux',
        'alixe'         => 'AliXe Linux',
        'annyung'       => 'AnNyung Linux',
        'antomic'       => 'Antomic Linux',
        'arabian'       => 'Arabian Linux',
        'ark'           => 'Ark Linux',
        'alt'           => 'ALT Linux',
        'asp'           => 'ASP Linux',
        'arch'          => 'Arch Linux',
        'calculate'     => 'Calculate Linux',
        'caldera'       => 'Caldera Linux',
        'centos'        => 'CentOS Linux',
        'corel'         => 'Corel Linux',
        'damnsmall'     => 'Damn Small Linux',
        'debian'        => 'Debian Linux',
        'edubuntu'      => 'Edubuntu Linux',
        'fedora'        => 'Fedora Linux',
        'fluxbuntu'     => 'Fluxbuntu Linux',
        'freespire'     => 'Freespire Linux',
        'gentoo'        => 'Gentoo Linux',
        'gobo'          => 'Gobo Linux',
        'gobuntu'       => 'Gobuntu Linux',
        'kanotix'       => 'Kanotix Linux',
        'kateos'        => 'KateOS Linux',
        'kiwi'          => 'Kiwi Linux',
        'knoppix'       => 'Knoppix Linux',
        'ksi'           => 'KSI Linux',
        'kubuntu'       => 'Kubuntu Linux',
        'kurumin'       => 'Kurumin Linux',
        'jamd'          => 'JAMD Linux',
        'lindows'       => 'Lindows Linux',
        'linspire'      => 'Linspire Linux',
        'lycoris'       => 'Lycoris Linux',
        'mandrake'      => 'Mandrake Linux',
        'mdk'           => 'Mandrake Linux',
        'mandriva'      => 'Mandriva Linux',
        'mepis'         => 'Mepis Linux',
        'mint'          => 'Mint Linux',
        'mythbuntu'     => 'Mythbuntu Linux',
        'morphix'       => 'Morphix Linux',
        'parsix'        => 'Parsix Linux',
        'plamo'         => 'Plamo Linux',
        'polarbear'     => 'Polar Bear Linux',
        'redhat'        => 'Red Hat Linux',
        'redflag'       => 'Red Flag Linux',
        'sabayon'       => 'Sabayon Linux',
        'sco'           => 'SCO Linux',
        'sidux'         => 'Sidux Linux',
        'slackware'     => 'Slackware Linux',
        'slax'          => 'Slax Linux',
        'SOT'           => 'SOT Linux',
        'sorcerer'      => 'Sorcerer Linux',
        'sourcemage'    => 'SourceMage Linux',
        'suse'          => 'SuSe Linux',
        'turbo'         => 'Turbo Linux',
        'trusted'       => 'Trusted Linux',
        'virtual'       => 'Virtual Linux',
        'vms'           => 'VMS Linux',
        'xandros'       => 'Xandros Linux',
        'xubuntu'       => 'Xubuntu Linux',
        'xp'            => 'Linux XP',
        'ubuntu'        => 'Ubuntu Linux',
        'linux'         => 'Linux'
    ),
    'bsd' => array( 
        'dragonflybsd'  => 'DragonFly BSD',
        'freebsd'       => 'Free BSD',
        'netbsd'        => 'Net BSD',
        'openbsd'       => 'Open BSD',
        'midnightbsd'   => 'Midnight BSD',
        'truebsd'       => 'True BSD',
        'pcbsd'         => 'PC BSD'
    ),
    'sunos' => array( 
        'sunos5.10'     => 'Solaris 10',
        'sunos5.9'      => 'Solaris 9',
        'sunos5.8'      => 'Solaris 8',
        'sunos5.7'      => 'Solaris 7',
        'sunos5.6'      => 'Solaris 2.6',
        'sunos5.5.1'    => 'Solaris 2.5.1',
        'sunos5.5'      => 'Solaris 2.5',
        'sunos5.4'      => 'Solaris 2.4',
        'sunos5.3'      => 'Solaris 2.3',
        'sunos5.2'      => 'Solaris 2.2',  
        'sunos5.1'      => 'Solaris 2.1',
        'sunos5.0'      => 'Solaris 2.0',
        'sunos'         => 'Solaris'
    ),
    'macintosh' => array( 
        'macosx10_6'    => 'Mac OS X Snow Leopard',
        'macosx10_5'    => 'Mac OS X Leopard',
        'macosx10_4'    => 'Mac OS X Tiger',
        'macosx10_3'    => 'Mac OS X Panther',
        'macosx10_2'    => 'Mac OS X Jaguar',
        'macosx10_1'    => 'Mac OS X Puma',
        'macosx10_0'    => 'Mac OS X Cheetah',
        'macosx'        => 'Mac OS X',
        'mac_powerpc'   => 'Mac PowerPC',
        'darwin'        => 'Darwin Mac OS',
        'iphone'        => 'OS X iPhone',
        'ipod'          => 'OS X iPod',
        'macintosh'     => 'Macintosh'
    ),
    'amiga'      => 'Amiga OS',
    'irix'       => 'IRIX OS',
    'hp-ux'      => 'HP-UX OS',
    'palmos'     => 'Palm OS',
    'reactos'    => 'React OS',
    'beos'       => 'BeOS',
    'blackberry' => 'BlackBerry OS',
    'os/2'       => 'OS/2',
    'unix'       => 'Unix OS'
);
?>