<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

if (!defined('FUNC_FILE')) die('Access is limited');

/**
* Output function pages without registration
* 
* @param string $content
* @param string $title
* @return void
*/
function page($content, $title){
global $config, $load_tpl;
require_once "includes/nocache.php";
die("<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
<html xmlns='http://www.w3.org/1999/xhtml'>
<head>
<title>{$title}</title>
<meta http-equiv='content-type' content='text/html; charset={$config['charset']}' />
<meta name='author' content='{$config['home_title']}' />
<meta name='resource-type' content='document' />
<meta name='document-state' content='dynamic' />
<meta name='distribution' content='global' />
<meta name='robots' content='index, follow' />
<meta name='revisit-after' content='1 days' />
<meta name='rating' content='general' />
<meta name='generator' content='{$config['cms_version']}' />
<meta name='description' content='{$config['description']}' />
<meta name='keywords' content='{$config['keywords']}' />
<meta name='Cache-Control' content='no-cache' />
<meta http-equiv='Expires' content='0' />
<meta name='copyright' content='Copyright (c){$config['cms_version']}' />
<base href='http://".get_host_name()."' />
<link rel='stylesheet' href='optimizer/?templates/{$load_tpl}/style.css' type='text/css' />
<link rel='stylesheet' href='optimizer/?includes/css/system.css' type='text/css' />
<link rel='shortcut icon' href='favicon.ico' type='image/x-icon' />
</head>
<body>
<script type='text/javascript' src='optimizer/?includes/javascript/ajax.js'></script>
<script type='text/javascript' src='optimizer/?includes/javascript/function.js'></script>
<script type='text/javascript' src='optimizer/?templates/{$load_tpl}/jsconfig.js'></script>
{$content}
</body>
</html>");
}

/**
* You can filter the received data
* 
* @param string $str
* @param mixed $html
* @return string
*/
function nc_filter($str, $html=''){
global $config, $filter;
    if(empty($str)) return '';
    if($html == TAGS) return strip_tags($str);
    if(!is_object($filter)) {
        if($config['typeEditor'] == '2') $tags = array("a", "b", "blink", "blockquote", "br", "caption", "center", "col", "colgroup", "comment", "li", "p",
            "em", "font", "h1", "h2", "h3", "h4", "h5", "h6", "hr", "img", "marquee", "pre",
            "small", "span", "strike", "strong", "sub", "sup", "table", "tbody", "td", "tfoot", "th", "s",
            "thead", "tr", "tt", "u", "ul", "ol");
        else $tags = array();
        $tags = array_unique(array_merge(explode(",", $config['htmlTags']), $tags));
        $attr = array("abbr", "align", "alt", "axis", "background", "behavior", "bgcolor", "border", "bordercolor",
            "bordercolordark", "bordercolorlight", "bottompadding", "cellpadding", "cellspacing", "char",
            "charoff", "cite", "clear", "color", "cols", "direction", "face", "font-weight", "headers",
            "height", "href", "hspace", "leftpadding", "loop", "noshade", "nowrap", "point-size", "rel",
            "rev", "rightpadding", "rowspan", "rules", "scope", "scrollamount", "scrolldelay", "size",
            "span", "src", "start", "summary", "target", "title", "toppadding", "type", "valign",
            "value", "vspace", "width", "wrap");
        require_once "includes/classes/filter.class.php";
        $filter->init($tags, $attr, false, false, true);
    }
    return $filter->process(str_replace('  ', ' ', $str));
}

/**
* You can filter the array to the specified key fields
* 
* @param array $array_kay
* @param string $name
* @param mixed $type
*/
function filter_arr($array_kay, $name, $type=""){
    if($name == POST) foreach ($array_kay as $value) $_POST[$value] = (isset($_POST[$value])) ? nc_filter($_POST[$value], $type) : "";
    elseif($name == GET) foreach ($array_kay as $value) $_GET[$value] = (isset($_GET[$value])) ? nc_filter($_GET[$value], $type) : "";
}

/**
* Function decode encoded with UTF8
* 
* @param string $str
* @return string
*/
function utf8decode($str){
global $config;
    $is_utf = is_utf8($str);
    if(nc_strtoupper($config['charset'])!='UTF-8'){
        if(function_exists('mb_convert_encoding') AND $is_utf) return mb_convert_encoding($str, nc_strtoupper($config['charset']), "UTF-8");
        elseif(function_exists('iconv') AND $is_utf) return iconv("UTF-8", nc_strtoupper($config['charset']), $str);
        else return $str;
    } else return $str;
}

/**
* Function encoding to UTF8
* 
* @param string $str
* @return string
*/
function utf8code($str){
global $config;
   $is_utf = is_utf8($str);
   if(function_exists('mb_convert_encoding') AND !$is_utf) return mb_convert_encoding($str, "UTF-8", $config['charset']);
   elseif(function_exists('iconv') AND !$is_utf) return iconv($config['charset'], "UTF-8", $str);
   else return $str;
}

/**
* Date function in Greenwich, taking into account the correction system
* 
* @param string $format
* @return string
*/
function nc_date($format){
global $config;
    return date($format, strtotime(gmdate($format))+(intval($config['GMT_correct'])*60*60));
}

/**
* Correction function output date
* 
* @param string $date
* @param string $format_date
* @return string
*/
require_once 'includes/classes/jcalendar.class.php';

function format_date($date, $format_date=""){
global $config, $userinfo, $language;
if($language == 'persian') {
$calendar = new jCalendar;
    if(empty($userinfo['user_gmt']) OR !isset($userinfo['user_gmt'])) $userinfo['user_gmt'] = 0;
    $GMT = $userinfo['user_gmt'];
    $format_date = (empty($format_date)) ? $config['date_format'] : $format_date;
    return (preg_match('/\+|([0-9]*)/', $GMT)) ? $calendar->date($format_date, strtotime($date)+intval($GMT)*(60*60)) : $calendar->date($format_date, strtotime($date)-intval($GMT)*(60*60));
} else {
    if(empty($userinfo['user_gmt']) OR !isset($userinfo['user_gmt'])) $userinfo['user_gmt'] = 0;
    $GMT = $userinfo['user_gmt'];
    $format_date = (empty($format_date)) ? $config['date_format'] : $format_date;
    return (preg_match('/\+|([0-9]*)/', $GMT)) ? date($format_date, strtotime($date)+intval($GMT)*(60*60)) : date($format_date, strtotime($date)-intval($GMT)*(60*60));
}
}

function dformat_date($date){
global $language;
if($language == 'persian') {
    $calendar = new jCalendar;
    $types = explode(" ", $date);
    $arrdate = explode("-", $types[0]);
    $arrtime = explode(":", $types[1]);
    $decode_date = $calendar->mktime($arrtime[0], $arrtime[1], $arrtime[2], $arrdate[1], $arrdate[2], $arrdate[0]);
        return date("Y-m-d H:i:s", $decode_date);
} else {
        return date("Y-m-d H:i:s", $date);
}
}
/**
* Function of the inverse correction date
* 
* @param string $date
* @param string $format_date
* @return string
*/
function backgmdate($date, $format_date=""){
global $config, $userinfo, $language;
if($language == 'persian') {
    $calendar = new jCalendar;
    $types = explode(" ", $date);
    $arrdate = explode("-", $types[0]);
    $arrtime = explode(":", $types[1]);
    $decode_date = $calendar->mktime($arrtime[0], $arrtime[1], $arrtime[2], $arrdate[1], $arrdate[2], $arrdate[0]);
        return date("Y-m-d H:i:s", $decode_date);
} else {
    if(empty($userinfo['user_gmt']) OR !isset($userinfo['user_gmt'])) $userinfo['user_gmt'] = 0;
    $GMT = $userinfo['user_gmt'];
    $format_date = (empty($format_date)) ? $config['date_format'] : $format_date;
    return (preg_match('/\+|([0-9]*)/', $GMT)) ? date($format_date, strtotime($date)-intval($GMT)*(60*60)) : date($format_date, strtotime($date)+intval($GMT)*(60*60));
}
}

/**
* Correction function output the date and identification of old publications. Today in ... Yesterday
* 
* @param mixed $date
* @return string
*/
function user_format_date($date, $his=false){
global $config, $lang;    
    $format_date = $config['date_format'];
    $d = format_date($date, "Y-m-d");
    $today = date("Y-m-d");
    if(date("Y-m-d", strtotime($d)+60*60*24)==$today OR $d==$today){
        if($d==$today) return "{$lang['today']} ".format_date($date, "H:i");
        else return "{$lang['yesterday']} ".format_date($date, "H:i");
    } elseif(!$his) return format_date($date, $format_date);
    else return format_date($date, "{$format_date} H:i:s");
}

/**
* The function checks whether the visitor search engine
* 
* @param string $name
* @param string $robots
*/
function check_bots($name){
global $list_bots;    ;
    foreach ($list_bots as $bot_name) {
        if (preg_match("/$bot_name/i", $name)) return true;
    }
    return false;
}

/**
* Removes a directory including subdirectories
* 
* @param string $dir
* @return bool
*/
function remove_dir($dir){
    if($dir[nc_strlen($dir)-1]!="/") $dir .= "/";
    if(preg_match('/(\/\/)/', $dir)) return false;
    if(nc_file_exists($dir) AND $handle = nc_opendir($dir)){
        while(($obj = readdir($handle))){
            if ($obj!="." AND $obj!=".."){
                if (nc_is_dir($dir.$obj)){
                    if (!remove_dir($dir.$obj)) return false;
                } else if(nc_is_file($dir.$obj)){
                           if (!nc_unlink($dir.$obj)) return false;
                       }
                }
       }
       closedir($handle);
       if(nc_file_exists($dir) AND @rmdir($dir)) return true;
       else return false;
   }
return false;
}

/**
* Returns the number of files in directories and subdirectories including
* 
* @param string $dir
* @param string $regEx
* @return int
*/
function dir_file_count($dir){
    if(!nc_file_exists($dir)) return false;
    if(nc_is_file($dir)) return 1;
    if(nc_is_dir($dir) AND $dh=nc_opendir($dir)){
        $size=0;
        while(($file=readdir($dh))!==false){
            if($file=="." OR $file=="..") continue;
            $size+=dir_file_count($dir."/".$file);
        }
        closedir($dh);
        return $size;
    } else return 0;
}

/**
* Returns the size of the files in directories and subdirectories including
* 
* @param string $dir
* @param int $buf
* @return int
*/
function dir_size($dir, $buf=2){
    static $buffer;
    if(isset($buffer[$dir])) return $buffer[$dir];
    if(nc_is_file($dir)) return nc_filesize($dir);
    if(($dh=nc_opendir($dir))){
        $size=0;
        while(($file=readdir($dh))!==false){
            if($file=="." OR $file=="..") continue;
            $size+=dir_size($dir."/".$file,$buf-1);
        }
        closedir($dh);
        if($buf>0) $buffer[$dir]=$size;
     return $size;
     }
return false;
}

/**
* Cuts the text from the beginning, the incoming text to a given word
* 
* @param string $text
* @param int $count
* @param string $return
* @return string
*/
function cut_text($text, $count=63, $return=""){
    $textarr = explode(" ", $text);
    if (count($textarr)>$count){
        for($i=0; $i<$count; $i++) $return .= $textarr[$i]." ";
        return $return."...";
    } else return $text;
}

/**
* Cuts the text from the beginning, the incoming text to a given word
* 
* @param string $text
* @param int $count
* @param string $return
* @return string
*/
function cut_char($text, $count=35, $return=""){
    if(nc_strlen($text)>$count) return $return.nc_substr($text, 0, $count)."...";
    else return $text;
}

/**
* Convert an array into the information line
* 
* @param array $var
* @param string $class
* @param string $text
* @return string
*/
function var2string($var, $class, $text){
    $string = "";
    foreach ($var as $var_name=>$var_value){
        if(!is_object($var_value)){
            if(!is_array($var_value)) $string .= "<span class='{$class}'>{$text}: </span>{$var_name} = {$var_value}<br />\n";
            else $string .= "<span class='{$class}'>{$text}: </span><pre>{$var_name} =  ".htmlspecialchars(var_export($var_value, true))."</pre><br />\n";  
        }
    }
    return $string;
}

/**
* Function transliteration
* 
* @param string $string
* @return string
*/
function cyr2lat($string){
    $cyr = array('а', 'б', 'в', 'г', 'д', 'е', 'ё', 'ж', 'з', 'и', 'й', 'к', 'л', 'м', 'н', 'о', 'п', 'р', 'с', 'т', 'у', 'ф', 'х', 'ц', 'ч', 'ш', 'щ', 'ъ', 'ы', 'ь', 'э', 'ю', 'я');
    $lat = array('a', 'b', 'v', 'g', 'd', 'e', 'e', 'zh', 'z', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'r', 's', 't', 'u', 'f', 'h', 'c', 'ch', 'sh', 'sch', '', 'y', '', 'je', 'ju', 'ya');
    $bad_sym = array("'", ' ', '"', '(', ')', '[', ']', '$', '#', '%', '!', '@', '^', '&', '*', ';', ':', '<', '>', '/', '\\', '|', '?', ',', '~', '`', '-');
    $replace_sym = array('', '-', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '');
    return str_replace($cyr, $lat, str_replace($bad_sym, $replace_sym, str_replace('  ', ' ', nc_chenge_reg($string))));
}  

/**
* Sobstennyh function strtolower
* 
* @param string $string
* @param string $type
* @return string
*/
function nc_chenge_reg($string, $type='lower'){
  $convert_to = array(
    "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u",
    "v", "w", "x", "y", "z", "à", "á", "â", "ã", "ä", "å", "æ", "ç", "è", "é", "ê", "ë", "ì", "í", "î", "ï",
    "ð", "ñ", "ò", "ó", "ô", "õ", "ö", "ø", "ù", "ú", "û", "ü", "ý", "а", "б", "в", "г", "д", "е", "ё", "ж",
    "з", "и", "й", "к", "л", "м", "н", "о", "п", "р", "с", "т", "у", "ф", "х", "ц", "ч", "ш", "щ", "ъ", "ы",
    "ь", "э", "ю", "я"
  );
  $convert_from = array(
    "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U",
    "V", "W", "X", "Y", "Z", "À", "Á", "Â", "Ã", "Ä", "Å", "Æ", "Ç", "È", "É", "Ê", "Ë", "Ì", "Í", "Î", "Ï",
    "Ð", "Ñ", "Ò", "Ó", "Ô", "Õ", "Ö", "Ø", "Ù", "Ú", "Û", "Ü", "Ý", "А", "Б", "В", "Г", "Д", "Е", "Ё", "Ж",
    "З", "И", "Й", "К", "Л", "М", "Н", "О", "П", "Р", "С", "Т", "У", "Ф", "Х", "Ц", "Ч", "Ш", "Щ", "Ъ", "Ъ",
    "Ь", "Э", "Ю", "Я"
  );

  if($type=='lower') return str_replace($convert_from, $convert_to, $string);
  else return str_replace($convert_to, $convert_from, $string);
} 
     
/** 
* Function redirecting the page
* 
* @param string $var
* @return void
*/
function redirect($var){
global $adminfile, $main;
    if(is_int($var)){
        if($var==BACK){
            $REFERER = nc_filter(get_env('HTTP_REFERER'), TAGS);
            if(is_ajax()) nc_header("Location: {$REFERER}&ajax=true");
            else nc_header("Location: {$REFERER}");
        }elseif($var==MODULE){
            if(is_ajax()){
                if(!defined("ADMIN_FILE")) nc_header("Location: ".$main->url(array('module' => $main->module))."&ajax=true");
                else nc_header("Location: {$adminfile}?module={$main->module}&ajax=true");
            } else {
                if(!defined("ADMIN_FILE")) nc_header("Location: ".$main->url(array('module' => $main->module)));
                else nc_header("Location: {$adminfile}?module={$main->module}");
            }
        }
    } else {
        $var = str_replace("amp;", "", $var);
        if(is_ajax()) nc_header("Location: {$var}&ajax=true");
        else nc_header("Location: {$var}");
    }
}

/**
* Creating feature editor
* 
* @param string $name
* @param int $rows
* @param string $size
* @param string $value
* @param int $type
* @param string $butons
* @return string
*/
function editor($name, $rows=5, $size='345px', $value="", $type=0, $butons=""){
global $editor_js, $tpl_create;
    $value = (isset($_POST[$name])) ? $_POST[$name] : $value;
    if($type==0){
        if(empty($value)) $value = (isset($_POST[$name])) ? stripslashes($_POST[$name]) : "";
        else $value = (isset($_POST[$name])) ? stripslashes($_POST[$name]) : $value;
    	$tpl_create->add2script("optimizer/?includes/javascript/bbeditor.js");
    	$tpl_create->add2script("NC_AJAX.addEvent(window, 'load', function(){bbeditor.init('{$name}', '{$butons}');});", false);
    	$r = "<table cellpadding='0' cellspacing='0' style='width: {$size}'><tr><td><textarea id='{$name}' name='{$name}' rows='".(is_int($rows)?$rows:5)."' cols='60' style='width: {$size};".(!is_int($rows)?" height:{$rows};":"")."' class='main_editor'>".htmlspecialchars($value, ENT_QUOTES)."</textarea></td></tr></table>";
    }
    $editor_js = true;
    return $r;
}

/**
* Function parse categories
* 
* @param string $string
* @return string
*/
function cat_parse($string){
global $main;
    if(empty($string)) return $main->lang['nocat'];
    $return = "";
    $cats = explode("|", $string);
    $count = count($cats);
    if($count>0 AND $string!='|'){
        for($i=0;$i<$count-1;$i++){
            $list = explode(",", $cats[$i]);
            $return .= "<a class='sys_link' href='".$main->url(array('module' => $main->module, 'do' => 'category', 'id' => case_id($list[2], $list[1])))."' title='{$main->lang['view_cat']}'>{$list[0]}</a>";
            $return .= ($i<$count-2) ? ", " : "";
        }
        return $return;
    } else return $main->lang['nocat'];
}

/**
* Selection Function URL identifier
* 
* @param mixed $rewrite_id
* @param mixed $id
* @return string
*/
function case_id($rewrite_id, $id){
global $main;
    if($main->mod_rewrite) return nc_encodeurl($rewrite_id);
    else return $id;
}

/**
* The function checks the passed parameters by POST
* 
* @param array $kays
* @param array $langs
* @param string $msg
*/
function error_empty($kays, $langs, $msg=""){
global $lang;
    foreach ($kays as $kay=>$value) if(empty($_POST[$value])) $msg .= (isset($lang[$langs[$kay]])) ? $lang[$langs[$kay]] : $langs[$kay];
    return $msg;
}

/**
* Function to check e-mail addresses for validity
* 
* @param mixed $email
* @resurn string
*/
function check_mail($email){
global $lang;
    if(empty($email) OR !preg_match('/^[_\.0-9a-z-]+@([0-9a-z-]+\.)+[a-z]{2,6}$/i', nc_strtolower($email))) return "{$lang['error_email']}";
    else return "";
}

/**
* The function convert a string to the URL given the option mod_rewrite
* 
* @param string $url
* @return string
*/
function nc_encodeurl($url){
global $main;
    if($main->rewrite_id) return str_replace('+', ' ', urlencode(utf8code($url)));
    else return urlencode($url);
}

/**
* Function convert URL to a string given the option mod_rewrite
* 
* @param string $url
* @return string
*/
function nc_decodeurl($url){
global $main;
    if($main->rewrite_id) return utf8decode(urldecode($url));
    else return urldecode($url);
}

/**
* Conversion function in the URL string
* 
* @param string $url
* @return string
*/
function nc_normalize_url($url){
   return urlencode(utf8code(urldecode($url)));
}

/**
* The function convert a string into a string array
* 
* @param string $string
* @param string $return
*/
function array_create($string, $return=""){
    $arr = explode(",", $string);
    $count = count($arr);
    for($i=0;$i<$count;$i++) $return .= ($i<$count-1) ? "'{$arr[$i]}', " : "'{$arr[$i]}'";
    return $return;
}

/**
* Function to check the array if the element found is returned otherwise its key
* 
* @param mixed $key
* @param mixed $array
* @return mixed
*/
function array_value_set($key, $array){
    if(isset($array[$key])) return $array[$key]; else return $key;
}

/**
* Function of the SQL INSERT query
* 
* @param arrray $array
* @param string $table
* @return resourse
*/
function sql_insert($array, $table){
global $db;
    $insert = "INSERT INTO `{$table}` (";
    $values = ") VALUES (";
    $count = count($array);
    $i=0;
    foreach ($array as $kay=>$value){
        $insert .= ($i<$count-1) ? "`{$kay}`, " : "`{$kay}`";
        $values .= ($i<$count-1) ? "'{$value}', " : "'{$value}'";
        $i++;
    }
    return $db->sql_query($insert.$values .= ");");
}

/**
* Function SQL query UPDATE
* 
* @param array $array
* @param string $table
* @param string $where
* @return resourse
*/
function sql_update($array, $table, $where){
global $db;
    $update = "UPDATE {$table} SET ";
    $count = count($array);
    $i=0;
    foreach ($array as $kay=>$value){
        $update .= ($i<$count-1) ? "`{$kay}`='{$value}', " : "`{$kay}`='{$value}'";
        $i++;
    }
    $update .= " WHERE {$where}";
    return $db->sql_query($update);
}
/**
* Replace into the application when pasting
* 
* @param mixed $array
* @param mixed $table
* @return resourse
*/
function sql_replace_into($array, $table){
global $db;
    $replace = "REPLACE INTO `{$table}` (";
    $values = ") VALUES (";
    $count = count($array);
    $i=0;
    foreach ($array as $kay=>$value){
        $replace .= ($i<$count-1) ? "`{$kay}`, " : "`{$kay}`";
        $values .= ($i<$count-1) ? "'{$value}', " : "'{$value}'";
        $i++;
    }
    return $db->sql_query($replace.$values .= ");");
}

/**
* Function is always positive CRC32
* 
* @param string $string
* @return string
*/
function crc32_integer($string){
    $crc32 = crc32($string);
    return(($crc32<0) ? $crc32*-1 : $crc32);
}    

/**
* Conversion function in an array of string array
* 
* @param array $array
* @param string $arr_name
* @param int $level
*/
function arr2str($array, $arr_name='data', $level=0){
    if($level==0) return '$'.$arr_name." = ".var_export($array, true).";";
    else return "array(".implode(", ",$array).")";
}

/**
* Function META redirects with displaying on the specified period of time
* 
* @param int $time
* @param string $url
* @param string $message
* @return void
*/
function meta_refresh($time, $url, $message=""){
    echo "<meta http-equiv='refresh' content='{$time}; url={$url}'>";
    if(!empty($message)) info($message);
}

/**
* Function of g-zip compression page
* 
* @param string $contents
* @return string
*/
function gz($contents){
global $config;
    if(!check_can_gzip() || $config['gz']!=ENABLED) echo $contents;
    else {
        if(strpos(' '.$_SERVER['HTTP_ACCEPT_ENCODING'], 'x-gzip') !== false) $_encoding = 'x-gzip';
        if(strpos(' '.$_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false) $_encoding = 'gzip';
        if(isset($_encoding)) {
            $_in = $contents;
            $_inlenn = strlen($_in);
            $_out = gzencode($_in, $config['gzlevel']);
            header('Content-Encoding: '.$_encoding);
            echo $_out;
        }  else echo $contents;
    }
}

/**
* Function to create cookies
* 
* @param string $value
* @param string $name
* @param int $time
*/
function setcookies($value, $name, $time=0){
global $config;
       $time = ($time==0) ? time() + 60*60*24*intval($config['time_of_life_session']) : $time;
       $time = ($time==1) ? 0 : $time;
       setcookie($name, $value, $time, "/");
}

/**
* Screening function
* 
* @param string $var
* @return string
*/
function magic_quotes($var){
global $magic_quotes;
    if($magic_quotes==true AND !is_array($var)){
        if(function_exists("mysql_escape_string")) return str_replace('\\\"', '"', mysql_escape_string(trim($var)));
        else return str_replace('\\\"', '"', addslashes(trim($var)));    
    } else return $var;
}

/**
* Function decode bb tag in HTML
* 
* @param string $string
* @param string $code
* @return string
*/
function bb($string, $code='encode'){
global $bb;
    require_once "includes/classes/bbcode.class.php";
    if($code=='encode'){
        $bb->set_text($string);
        return addslashes($bb->get_html());
    } else {
        $bb->text = $string;
        $bb->html2bb();
        return $bb->get_bb();
    }
}

/**
* An additional function of decoding bb tag in HTML
* 
* @param string $text
* @return string
*/
function parse_bb($text){
global $bb, $config, $tpl_create;
    $text = str_replace(array('</td><br />', '</tr><br />'), array('</td>', '</tr>'), $text);
    $text = preg_replace('/<table(.*?)><br \/>/is', '<table\\1>', $text);
    if(!is_object($bb)) require_once "includes/classes/bbcode.class.php";
    if($config['imgpdaversion']!=ENABLED AND $config['pdaversion']==ENABLED){
        require_once "includes/function/pda.php";
        if(check_pda()) $text = preg_replace('/<img(.*?)>/si', '', $text);
    }  
  if(preg_match('/<\!\-\-start\sminiature\-\->(.+?)<\!\-\-end miniature\-\->/', $text)) $tpl_create->add2script('optimizer/?includes/javascript/highslide/highslide.js');
    if(preg_match('/(.*?)(\[(flash.*|video|mp3|radio|hide|cite.*|code|php|html|css|xml|javascript|java|cpp|delphi|python|ruby|sql)\])(.*?)/si', $text)){
        $bb->text = $text;
        $bb->other_bb();
        return stripcslashes($bb->get_bb());
    } else return stripcslashes($text);
}

/**
* The feature downloadable template
* 
* @return void
*/
function load_tpl(){
global $config, $load_tpl, $tpl_config, $main, $userinfo;
    if(defined("ADMIN_FILE")) $load_tpl = "admin";
    elseif(!is_user()) $load_tpl = $config['template'];
    elseif(isset($main->user['user_template']) AND $config['case_template']==ENABLED AND nc_file_exists("templates/{$main->user['user_template']}")) $load_tpl = $main->user['user_template'];
    elseif(isset($main->user['user_template']) AND empty($main->user['user_template'])) $load_tpl = $config['template'];    
    else $load_tpl = $config['template'];
    if(!defined("ADMIN_FILE") AND isset($_COOKIE['them']) AND preg_match('/[a-z0-9\-_]/is', $_COOKIE['them']) AND nc_file_exists("templates/{$_COOKIE['them']}/")) $load_tpl = $_COOKIE['them'];
    if(!preg_match('/^([a-z0-9\-_]*)$/i', $load_tpl))  $load_tpl = $config['template']; 
    if($config['pdaversion']==ENABLED){
        require_once "includes/function/pda.php";
        if(check_pda()) $load_tpl = 'pda'; 
    }
    if(nc_file_exists("templates/{$load_tpl}/config_tpl.php")) require_once "templates/{$load_tpl}/config_tpl.php";
}

/**
*Function to create a parser variables
* 
* @return void
*/
function variables(){
global $variable;
    if(isset($_GET)) $variable['GET'] = var2string($_GET, 'get_var', 'GET');
    if(isset($_POST)) $variable['POST'] = var2string($_POST, 'post_var', 'POST');
    if(isset($_SESSION)) $variable['SESSION'] = var2string($_SESSION, 'session_var', 'SESSION');
    if(isset($_COOKIE)) $variable['COOKIE'] = var2string($_COOKIE, 'cookie_var', 'COOKIE');
    if(isset($_FILES)) $variable['FILES'] = var2string($_FILES, 'files_var', 'FILES');
    $variable['SESSIONID'] = "<span class='files_var'>SESSION_ID: </span>".session_id()."<br />\n";
}

/**
* A synonym for function header
* 
* @param mixed $command
* @return void
*/
function nc_header($command){
    header($command);
    exit;
}

/**
* Function to send e-mail messages
* 
* @param string $to
* @param string $sender
* @param string $from
* @param string $from_name
* @param string $subject
* @param string $body
* @return bool
*/
function send_mail($to, $sender, $from, $from_name, $subject, $body){
global $config;    
    require_once "includes/classes/mail.class.php"; 
    $sender = parse_mylang($sender);    
    $from_name = parse_mylang($from_name);
    $subject = parse_mylang($subject);
    $body = parse_mylang($body);
    $body = str_replace("\n", "<br />", $body);
    $mail = new mailman();
    if($config['log_emails_send']==ENABLED) $mail->log = true;
    if($config['send_mail']!=ENABLED) $mail->sending = false;
    $mail->smtp = ($config['type_email_send']!='mail') ? true : false;
    $mail->charset = $config['charset_mail'];
    $mail->is_html = ($config['type_emeils']=='text/html') ? true : false;
    $header = array(
        'To' => "{$sender} <{$to}>",
        'From' => "{$from_name} <{$from}>",
        'Subject' => $subject,
    );    
    $mail->send($to, $header, $body);
}

/**
* Function pagination
* 
* @param mixed $count
* @param mixed $this_page
* @param array $url_array
*/
function other_pages_list($count, $this_page, $url_array){
global $main;
    $uris = array();
    $pages = "<div class='pagebreak' id='{$main->module}_other_pages'>";
    if ($count > 1) {
        if (isset($this_page) AND $this_page>1){
            $pages .= "<a class='sys_link' href='\$uris[".count($uris)."]'><b>&#171;</b></a>";
            $uris[] = $this_page-1;
        }
        for ($i=1;$i<=$count;$i++) {
            if ($i == $this_page) $pages .= "<b class='noselect'>{$i}</b>";
            elseif((($i > ($this_page - 5)) AND ($i < ($this_page + 5))) OR ($i == $count) OR ($i == 1)){
                $pages .= "<a class='sys_link' href='\$uris[".count($uris)."]'><b>{$i}</b></a>";
                $uris[] = $i;
            } elseif ($i<$count AND ($count>6 AND $i==1) OR ($pagenum<$count-5 AND $i==$count-1)) $pages .= "<b class='noselect'>...</b>";
        }
        if ($this_page<$count) {
            $pages .= "<a class='sys_link' href='\$uris[".count($uris)."]'><b>&#187;</b></a>";
            $uris[] = $this_page+1;
        }
        foreach($uris as $kay=>$value) $uris_link[$kay] = $main->url($url_array+array('pagebreak' => $value)+(isset($_GET['page']) ? array('page' => $_GET['page']) : array()));
        $pages = preg_replace('/\$uris\[([0-9]*)\]/sie', "\$uris_link['\\1']", $pages);
    }
    return $pages."</div>";
}

/**
* Function parse tag page_breack
* 
* @param string $text
* @param mixed $config
* @return string
*/
function pagebreak($text, $config){
global $main;
    if($config!=ENABLED) return $text = preg_replace('/\[PAGE_BREAK\]/is', '', $text);
    else{
        if(preg_match('/\[PAGE_BREAK\]/s', $text)){
            $arr_page = explode("[PAGE_BREAK]", $text);
            $main->parse_rewrite(array('module', 'do', 'id', 'pagebreak', 'page'));
            $link = array('module' => $main->module, 'do' => $_GET['do'], 'id' => $_GET['id']);
            if(isset($_GET['pagebreak']) AND isset($arr_page[$_GET['pagebreak']-1])) return $arr_page[intval($_GET['pagebreak'])-1].other_pages_list(count($arr_page), intval($_GET['pagebreak']), $link);
            else return $arr_page[0].other_pages_list(count($arr_page), 1, $link);
        } else return $text;
    }
}

/**
* The function rename temporary directory attachments
* 
* @param string $source
* @param string $dest
* @return bool
*/
function rename_attach($source, $dest){
global $main;
    $result = $main->db->sql_query("SELECT id, path FROM ".ATTACH." WHERE path LIKE '{$source}%'");
    if($main->db->sql_numrows($result)>0 AND $source!=$dest){
        if(nc_file_exists($source)) nc_rename($source, $dest);
        while(($row = $main->db->sql_fetchrow($result))) sql_update(array('path' => str_replace($source, $dest, $row['path'])), ATTACH, "id='{$row['id']}'");
        return true;
    } else {
        if(nc_file_exists($source)) {
            if(dir_file_count($source)==0) remove_dir($source);
            elseif($source!=$dest) nc_rename($source, $dest);
        }
        return false;
    }
}

/**
* Encryption password, users
* 
* @param string $string
* @return string
*/
function pass_crypt($string){
    return md5($string);
}

/**
* Function add items to the user
* 
* @param int $points
* @return void
*/
function add_points($points=0){
global $main;
    if($main->user['uid']!='-1') {
        if(isset($_SESSION['cache_session_user'])) unset($_SESSION['cache_session_user']);
        $main->user['user_points'] += $points;
        $main->db->sql_query("UPDATE ".USERS." SET user_points=user_points+{$points} WHERE uid='{$main->user['uid']}'");
        list($special) = $main->db->sql_fetchrow($main->db->sql_query("SELECT special FROM ".GROUPS." WHERE id={$main->user['user_group']}"));
        if($special!="1"){
            list($gid, $points) = $main->db->sql_fetchrow($main->db->sql_query("SELECT id, points FROM ".GROUPS." WHERE id>'{$main->user['user_group']}' AND special=0 ORDER BY id LIMIT 1"));
            if($main->user['user_points']>=$points AND !empty($gid)) $main->db->sql_query("UPDATE ".USERS." SET user_group='{$gid}' WHERE uid='{$main->user['uid']}'");
        }
    }
}

/**
* The function creates a string variable from GET array of fluid pages
* 
* @param array $ignore
* @param array $ignore_key
* @return string
*/
function parse_get($ignore=array(), $ignore_key=array()){
    $GET = $_GET; $url = "";
    foreach($GET as $key => $value) $url .= (!in_array($key, $ignore) AND !isset($ignore_key[$key])) ? "&amp;{$key}={$value}" : "";
    return $url;
}

/**
* Function to create a tag list
* 
* @param string $tags_str
* @param string $modul
* @return string
*/
function list_tags($tags_str, $modul){
global $main;
    $tags_list = '';
    if ($tags_str!= '') {
        $tags_arr = explode(',', $tags_str);
        foreach ($tags_arr as $key => $value)  $tags_list.= "<span class='tag'><a href='".$main->url(array('module' => $modul, 'do' => 'tags', 'id' => nc_encodeurl($value)))."' title='{$main->lang['tags_goto']} {$value}'>{$value}</a></span>&nbsp;";
    }
    return $tags_list;
}

/**
* Function to create a tag cloud
* 
* @param string $modul
* @param string $limit
* @return string
*/
function nc_create_tags($modul='', $limit='') {
global $main;
    $content = '';
    $count = $tags = array();
    $sizes = array('tag_level1', 'tag_level2', 'tag_level3', 'tag_level4', 'tag_level5');
    $where = ($modul=='') ? '' : "WHERE modul='{$modul}'";
    $limit = ($limit=='') ? '' : "LIMIT {$limit}";
    $result = $main->db->sql_query("SELECT tag, COUNT(*) AS count FROM ".TAG." {$where} GROUP BY tag ORDER BY count DESC {$limit}");
    if ($main->db->sql_numrows($result)>0) {
        while(($row = $main->db->sql_fetchrow($result))) {
            $tags['tags'][]  = $row['tag'];
            $tags['count'][] = $row['count'];
        }
        $min = min($tags['count']); $max = max($tags['count']); $res = $max - $min;
        foreach ($tags['count'] as $kay => $value) {
            $i = ($res) ? floor(($value-$min)/$res*4) : 0;
            $tags['size'][] = $sizes[$i];
        }
        uasort($tags['tags'], 'nc_sort_tag');
        foreach ($tags['tags'] as $kay => $value) $content.= "&nbsp;&nbsp;<a href='".$main->url(array('module' => $modul, 'do' => 'tags', 'id' => urlencode($value)))."' class='{$tags['size'][$kay]}' title='{$main->lang['tags_goto']} {$value} ({$tags['count'][$kay]}).'>{$value}</a> ";
    }
    return $content;
}

/**
* The function of sorting an array of tags
* 
* @param string $a
* @param string $b
* @return string
*/
function nc_sort_tag($a, $b) {
    return ($a == $b) ? 0 : strcmp($a , $b);
}

function set_calendar_date($id, $module, $date, $status){
global $main, $language;
if($language == 'persian') {
    $calendar = new jCalendar;
    $types = explode(" ", $date);
    $arrdate = explode("-", $types[0]);
    //$arrtime = explode(":", $types[1]);
    $decode_date = $calendar->mktime($arrdate[1], $arrdate[2], $arrdate[0]);
    $date_convert = date("Y-m-d H:i:s", $decode_date);
} else {
    $date_convert = date("Y-m-d H:i:s", $date);
}
    $result = $main->db->sql_query("SELECT * FROM ".CALENDAR." WHERE module='{$module}' AND id='{$id}'");
    if($main->db->sql_numrows($result)>0){
        $main->db->sql_query("UPDATE ".CALENDAR." SET status='{$status}', date='{$date_convert}' WHERE module='{$module}' AND id='{$id}'");
    } else $main->db->sql_query("INSERT INTO ".CALENDAR." (id, module, date, status) VALUES ('{$id}', '{$module}', '{$date_convert}', '{$status}')");
}

function rating_calc($id, $id_star, $rating, $table="", $voted=0, $hover=true, $class='unit-rating'){
global $lang;
    if(!$hover) return "<div class='rating' id='rating{$id_star}'><ul class='unit-rating'><li class='current-rating' style='width:".(round($rating, 2)*17)."px;'>".(round($rating, 2)*17)."</li></ul></div>";
    else {
        if(isset($_COOKIE['rating']) AND nc_strpos($_COOKIE['rating'], $table.$id.", ")!==false) return "<div class='rating' id='rating{$id_star}'><ul class='{$class}'><li class='current-rating' style='width:".(round($rating, 2)*17)."px;'>".(round($rating, 2)*17)."</li></ul></div>";
        return "<div class='rating' id='rating{$id}'><ul class='{$class}'><li class='current-rating' style='width:".round($rating*17, 2)."px;'>".round($rating*17, 2)."</li><li><a href='#' title='{$lang['r1']}' class='r1-unit' onclick=\"set_rating({$id}, '{$table}', 1, {$rating}, {$voted}); return false;\">1</a></li><li><a href='#' title='{$lang['r2']}' class='r2-unit' onclick=\"set_rating({$id}, '{$table}', 2, {$rating}, {$voted}); return false;\">2</a></li><li><a href='#' title='{$lang['r3']}' class='r3-unit' onclick=\"set_rating({$id}, '{$table}', 3, {$rating}, {$voted}); return false;\">3</a></li><li><a href='#' title='{$lang['r4']}' class='r4-unit' onclick=\"set_rating({$id}, '{$table}', 5, {$rating}, {$voted}); return false;\">4</a></li><li><a href='#' title='{$lang['r5']}' class='r5-unit' onclick=\"set_rating({$id}, '{$table}', 5, {$rating}, {$voted}); return false;\">5</a></li></ul></div>";
    }
}
variables();
?>