<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

if (!defined('FUNC_FILE')) die('Access is limited');

class tpl_main{
    var $cache = array();

    function open_table(){
    global $load_tpl;
        if(!isset($this->cache['open_table'])) return loads_tpl("templates/{$load_tpl}/open_table");
        else return $this->cache['open_table'];
    }

    function close_table(){
    global $load_tpl;
        if(!isset($this->cache['close_table'])) return loads_tpl("templates/{$load_tpl}/close_table");
        else return $this->cache['close_table'];
    }

    function publisher(){
    global $load_tpl;
        if(!isset($this->cache['publisher'])) return loads_tpl("templates/{$load_tpl}/publisher");
        else return $this->cache['publisher'];
    }
}

class pub_list{
    var $row_tpl;
    var $tpl;
    var $content = "";
    var $replace_title = false;

    function pub_list($id = ''){
    global $load_tpl, $module_name;
        if(nc_file_exists("templates/{$load_tpl}/publisher_list-{$module_name}.tpl")) $file = "templates/{$load_tpl}/publisher_list-{$module_name}.tpl";
        else $file = "templates/{$load_tpl}/publisher_list.tpl";
        $content = nc_get_content($file);
        $this->row_tpl = preg_replace('/(.+?)<\!--BEGIN row-->(.+?)<\!--END row-->(.+?)$/si', "\\2", $content);
        $this->tpl = preg_replace('/<\!--BEGIN\srow-->(.+?)<\!--END\srow-->/si', '<!--content-->', $content);
    }

    function add_row($id, $pub){
        $this->content .= preg_replace('#\$pub\[([a-z_-]+)\]#ise', "\$pub['\\1']", $this->row_tpl);
        if(!$this->replace_title){
            $this->tpl = preg_replace('#\$pub\[([a-z_-]+)\]#ise', "\$pub['\\1']", $this->tpl);
            $this->replace_title = true;
        }
    }

    function init($return=false){
        $row = preg_replace('/<\!--content-->/si', $this->content, $this->tpl);
        if (!$return) {
            open();
            echo $row;
            close();
        } else return $row;
        return "";
    }
}

//Creates the page's title as well as keywords and description
function set_meta_value($array){
global $keywords, $description, $page_title, $config;
    $page_title = "";
    $keywords = "";
    $description = "";
    $count = count($array);
    for ($i=0; $i<$count; $i++){
        $page_title .= ($i<$count-1) ? "{$array[$i]} {$config['separator']} " : "{$array[$i]}";
        $keywords .= $array[$i].", ";
        $description .= $array[$i].", ";
    }
    $page_title .= " @ {$config['home_title']}";
}

class tpl_create{
    var $design = true;
    var $script = array();
    var $link = array();
    var $rss = "";
    var $cache_link = array();
    var $cache_script = array();
    var $css_head_link=array();
    var $css_head=array();
    var $js_head_link=array();
    var $js_head=array();
    
    function add2script($text, $link=true){
        if(!in_array($text, $this->script)) $this->script[] = array($text, $link);
        else return false;
        return true;
    }

    function add2link($url){
        if(!in_array($url, $this->link)) $this->link[] = $url;
        else return false;
        return true;
    }
    /**
    * Adds $css_text in style head page
    * 
    * @param mixed $css_text
    */
    function add_css2head($css_text){
       $this->css_head[] = $css_text;
    }
    /**
    * Prisoedenyayus $file in the head page
    * 
    * @param mixed $file
    */
    function add_cssfile2head($file){
       if(!in_array($file, $this->css_head_link)) $this->css_head_link[] = $file;
    }
    
    function add_javascript2body($js_text){
       $this->js_head[] = $js_text;
    }
    
    function add_javascript_file2body($file){
       if(!in_array($file, $this->js_head_link)) $this->js_head_link[] = $file;
    }
    
    //Function generating meta tags
    function meta_insert(){
    global $config, $keywords, $description, $version_sys;
        return "<meta http-equiv='content-type' content='text/html; charset={$config['charset']}' />\n".
            "<meta name='author' content='".$config['home_title']."' />\n".
            "<meta name='copyright' content='Copyright (c) Nova CMS {$config['cms_version']}' />\n".
            "<meta name='resource-type' content='document' />\n".
            "<meta name='document-state' content='dynamic' />\n".
            "<meta name='distribution' content='global' />\n".
            "<meta name='robots' content='index, follow' />\n".
            "<meta name='revisit-after' content='1 days' />\n".
            "<meta name='rating' content='general' />\n".
            "<meta name='generator' content='Nova CMS {$version_sys}' />\n".
            "<meta name='description' content='{$description}{$config['description']}' />\n".
            "<meta name='keywords' content='{$keywords}{$config['keywords']}' />\n".
        "<base href='http://".get_host_name()."' />";
    }

    function javascript_insert(){
    global $load_tpl, $config;
        $script = "";$jqscript=array();
        if(!is_ajax()){
            if($config['jquery']!='noload') $jqscript[] = ($config['jquery']=='local') ? array('optimizer/?includes/javascript/jquery/jquery.js', true) : array('http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js', true);
            $this->script = array_merge($jqscript, array(array("optimizer/?includes/javascript/ajax.js", true), array("optimizer/?includes/javascript/function.js", true)), $this->script);
            if(defined("ADMIN_FILE")) $this->script[] = array('optimizer/?includes/javascript/adminJS.js', true);
        }
        foreach($this->script as $l) {
            if(!empty($l[0])){
                if($l[1]==true) $script .= "<script type='text/javascript' src='{$l[0]}'></script>\n";
                else $script .= "<script type='text/javascript'>{$l[0]}</script>\n";
            }
        }
        $js_source="";
        foreach($this->js_head_link as $l) {
            if(!empty($l)) $js_source .= nc_get_content($l)."\n";
        }
        foreach($this->js_head as $l) {
            if(!empty($l)) $js_source .= $l."\n";
        }
        if ($js_source!=""){$script.="<script type='text/javascript'><!--\n{$js_source}\n//--></script>\n";}
        return $script;
        
    }

    function link_insert(){
    global $load_tpl, $userinfo;
        $link = "";
        if(!is_ajax()) $this->link = array_merge(array("optimizer/?templates/{$load_tpl}/style.css", "optimizer/?includes/css/system.css"), $this->link);
        if(nc_strpos(get_env('HTTP_USER_AGENT'), 'Opera') !== false) $this->link[] = (nc_file_exists("optimizer/?templates/{$load_tpl}/css/opera.css")) ? "optimizer/?templates/{$load_tpl}/css/opera.css" : '';
        elseif(preg_match('/Flock|Phoenix|Firebird|Firefox|Shiretoko|NetPositive/i', get_env('HTTP_USER_AGENT'))) $this->link[] = (nc_file_exists("optimizer/?templates/{$load_tpl}/css/firefox.css")) ? "optimizer/?templates/{$load_tpl}/css/firefox.css" : '';
        elseif(nc_strpos(get_env('HTTP_USER_AGENT'), 'MSIE') !== false) $this->link[] = (nc_file_exists("optimizer/?templates/{$load_tpl}/css/ie.css")) ? "optimizer/?templates/{$load_tpl}/css/ie.css" : '';
        elseif(nc_strpos(get_env('HTTP_USER_AGENT'), 'Chrome') !== false) $this->link[] = (nc_file_exists("optimizer/?templates/{$load_tpl}/css/сhrome.css")) ? "optimizer/?templates/{$load_tpl}/css/сhrome.css" : '';
        elseif(nc_strpos(get_env('HTTP_USER_AGENT'), 'Safari') !== false) $this->link[] = (nc_file_exists("optimizer/?templates/{$load_tpl}/css/safari.css")) ? "optimizer/?templates/{$load_tpl}/css/safari.css" : '';
        foreach($this->link as $l) {
            if(!empty($l)) $link .= !is_ajax() ? "<link rel='stylesheet' href='{$l}' type='text/css' />\n" : "<script type='text/javascript'>NC_AJAX.include.style('{$l}')</script>";
        }
        $css_source="";
        foreach($this->css_head_link as $l) {
            if(!empty($l)) $css_source .= nc_get_content($l)."\n";
        }
        foreach($this->css_head as $l) {
            if(!empty($l)) $css_source .= $l."\n";
        }
        if ($css_source!=""){$link.="<style type='text/css'>\n{$css_source}\n</style>\n";}
        return !is_ajax() ? "<link rel='shortcut icon' href='http://".get_host_name()."favicon.ico' type='image/x-icon' />\n".$link.$this->rss : $link;
    }

    //Function to list the global variables
    function variable_insert(){
    global $variable;
        return "<div class='variables-title' id='variables-title' onclick=\"switch_content('variables')\">Variables Inform</div>".
        "<div class='variables' id='variables' style='display: none;' align='left'>{$variable['GET']}{$variable['POST']}{$variable['SESSION']}{$variable['SESSIONID']}{$variable['COOKIE']}{$variable['FILES']}</div>";
    }

    //Function display a list of database queries
    function query_insert(){
    global $db;
        if(defined("INSTALLCMS") OR defined("ADMIN_FILE")) return "";
        $query = $db->time_query;
        return ($query!="") ? "<div onclick=\"switch_content('query')\" class='query-title' id='query-title'>Query Inform</div><div style='display: none;' class='query' id='query'>{$query}</div>" : "";
    }

    function tpl_creates(){
    global $template, $load_tpl, $load_tpl, $config, $add_style, $agentinfo, $lang, $main;
        //Check the event scheduler
        $this->check_planner();
        if(nc_file_exists("optimizer/?templates/{$load_tpl}/css/".nc_strtolower($agentinfo['browser']).".css")) $this->add2link("optimizer/?templates/{$load_tpl}/css/".nc_strtolower($agentinfo['browser']).".css");
        $template->template = preg_replace('#\$lang\[([a-z_-]+)\]#ise', "array_value_set('\\1', \$lang)", $template->template);
        $template->template = preg_replace('#\$user\[([a-z_-]+)\]#ise', "array_value_set('\\1', \$main->user)", $template->template);
        $template->template = preg_replace('#\$module\[([a-z_-]+)\]#ise', "\$main->url(array('module' => '\\1'))", $template->template);
        $template->set_tpl('$host', get_host_name());
        //Insert the name of the current pattern
        $template->set_tpl('$load_tpl', $load_tpl);
        
        $template->set_tpl('$direction', $lang['direction']);
        //Insert page title
        $template->set_tpl('$title', $this->title_insert());
        //Inserts meta tags
        $template->set_tpl('$meta', $this->meta_insert());
        //Insert javascript
        $script = $this->javascript_insert();
        $template->set_tpl('$script', nc_substr($script, 0, nc_strlen($script)-1));
        //Box Style Sheets
        $link = $this->link_insert();
        $template->set_tpl('$link', nc_substr($link, 0, nc_strlen($link)-1).$add_style);
        $template->set_tpl('$license', "Copyright &copy;2005-2011 by <a href='http://www.nova-cms.com/' target='_BLANK' title='Content Management System'>Nova CMS</a>.");
        //Connection of additional user-defined functions template
        if(nc_file_exists("templates/{$load_tpl}/tpl.php")) require_once "templates/{$load_tpl}/tpl.php";
        //Insert analysis of variables
        $template->set_tpl('$var_info', (($config['variables']==1) OR ($config['variables']==2 AND is_admin())) ? $this->variable_insert() : "");
        //Inserting database queries
        $template->set_tpl('$query_info', (($config['query']==1) OR ($config['query']==2 AND is_admin())) ? $this->query_insert() : "");
        if(!defined("INSTALLCMS")){
            $time_db = $main->db->total_time_db;
            $num_queries = $main->db->num_queries;
        }
        if(is_ajax()){ 
            echo $this->javascript_insert();
            echo $this->link_insert();
        }
    }
    
    function check_planner(){
    global $planner;
        foreach($planner as $id => $run){
            if(gmdate('Y-m-d', strtotime($run['nextrun']))<=nc_date('Y-m-d H:i')){
                if(gmdate('H:i', strtotime($run['nextrun']))<=nc_date('H:i') AND in_array(gmdate('w'), explode(',', $run['weekdays'])) AND $run['status']==ENABLED) {
                    $this->add2script("NC_AJAX.addEvent(window, 'load', function(){haja({action:'index.php?ajaxed=runer', animation:false}, {}, {})});", false);
                    break;
                }
            }
        }
    }
}

//The feature downloadable template
function get_index(){
global $module_name, $load_tpl;
    if(isset($_GET['id']) AND nc_file_exists("templates/{$load_tpl}/index-{$module_name}-{$_GET['id']}.tpl")) return "templates/{$load_tpl}/index-{$module_name}-{$_GET['id']}.tpl";
    elseif(nc_file_exists("templates/{$load_tpl}/index-{$module_name}.tpl") AND isset($_GET['module'])) return "templates/{$load_tpl}/index-{$module_name}.tpl";
    elseif(nc_file_exists("templates/{$load_tpl}/index-home.tpl") AND !isset($_GET['module'])) return "templates/{$load_tpl}/index-home.tpl";
    else return "templates/{$load_tpl}/index.tpl";
}

function open_table($return=false){
global $tpl_main;
    $content = $tpl_main->open_table();
    if($return) return $content;
    else echo $content;
    return "";
}

function close_table($return=false){
global $tpl_main;
    $content = $tpl_main->close_table();
    if($return) return $content;
    else echo $content;
    return "";
}

function warning($string, $return=false){
global $module_name, $load_tpl;
    if(nc_file_exists("templates/{$load_tpl}/warning-{$module_name}.tpl")) $warning_tpl = "templates/{$load_tpl}/warning-{$module_name}.tpl";
    else $warning_tpl = "templates/{$load_tpl}/warning.tpl";
    $warning = str_replace('$load_tpl', $load_tpl, nc_get_content($warning_tpl));
    $warning = str_replace('$content', $string, $warning);
    if($return) return $warning;
    else echo $warning;
    return "";
}

function info($string, $return=false){
global $module_name, $load_tpl;
    if(!defined("ENGINE")){
        if(nc_file_exists("templates/{$load_tpl}/info-{$module_name}.tpl")) $info_tpl = "templates/{$load_tpl}/info-{$module_name}.tpl";
        else $info_tpl = "templates/{$load_tpl}/info.tpl";
        $info = str_replace('$load_tpl', $load_tpl, nc_get_content($info_tpl));
        $info = str_replace('$content', $string, $info);
        if($return) return $info;
        else echo $info;
    }
    return "";
}

function open($return=false){
    if($return) return open_table($return);
    else open_table($return);
    return "";
}

function close($return=false){
    if($return) return close_table($return);
    else close_table($return);
    return "";
}

function title($title_set, $return=false){
global $module_name;
    $title = open(true);
    $title .= "<h1 id='style_{$module_name}' class='module_title'>{$title_set}</h1>";
    $title .= close(true);
    if($return) return $title;
    else echo $title;
    return "";
}

function total_pages($numrows, $limit, $numpages){
global $lang;
    return "<h4>".preg_replace(array("#{TOTAL}#", "#{PAGES}#", "#{COUNT}#"), array($numrows, $numpages, $limit), $lang['total_pages'])."</h4>";
}

function pages($numrows, $limit, $url_array, $total=false, $return=false, $last_url_array=array(), $parse_get=false, $table_align=''){
global $main, $lang, $adminfile;
    $rew = $main->mod_rewrite; $content = '';
    if(defined('ADMIN_FILE')) $main->mod_rewrite = false;
    if(isset($_GET['page'])) add_meta_value($lang['title_page'].intval($_GET['page']));
    $numpages = ceil($numrows / $limit); $pagenum = (isset($_GET['page']) AND !empty($_GET['page'])) ? intval($_GET['page']) : 1;
    if($pagenum<=$numpages){
        if ($numpages > 1) {
            $content = "<div class='basepub'><div class='basenumbers'><div class='binner'><div class='numbers'>";
            if($total) $content .= total_pages($numrows, $limit, $numpages);
            $content .= "<table".(!empty($table_align)?" align='{$table_align}' style='margin: 0;'":'')."><tr><td>";
            if(isset($pagenum) AND $pagenum>1) $content .= "<a class='sys_link' href='".$main->url(array_merge($url_array, array('page' => $pagenum-1), $last_url_array), defined('ADMIN_FILE')?$adminfile:"").($parse_get==true?parse_get(array('page', 'delete', 'change_op'), array_merge($url_array, $last_url_array)):"")."'><b class='arrowleft'>&#171;</b></a>";
            for ($i=1;$i<=$numpages;$i++) {
                if ($i == $pagenum) $content .= "<span class='noselect'><b>{$i}</b></span>\n";
                elseif((($i > ($pagenum - 5)) AND ($i < ($pagenum + 5))) OR ($i == $numpages) OR ($i == 1)) $content .= "<a class='sys_link' href='".$main->url(array_merge($url_array, array('page' => $i), $last_url_array), defined('ADMIN_FILE')?$adminfile:"").($parse_get==true?parse_get(array('page', 'delete', 'change_op'), array_merge($url_array, $last_url_array)):"")."'><b>{$i}</b></a>\n";
                elseif ($i<$numpages AND ($pagenum>6 AND $i==1) OR ($pagenum<$numpages-5 AND $i==$numpages-1)) $content .= "<span class='more'><b>...</b></span>\n";
            }
            if($pagenum<$numpages) $content .= "<a class='sys_link' href='".$main->url(array_merge($url_array, array('page' => $pagenum+1), $last_url_array), defined('ADMIN_FILE')?$adminfile:"").($parse_get==true?parse_get(array('page', 'delete', 'change_op'), array_merge($url_array, $last_url_array)):"")."'><b class='arrowright'>&#187;</b></a>";
            $content .= "</td></tr></table></div></div></div></div>";
        }
        if($return) return $content;
        else echo $content;
        $main->mod_rewrite = $rew;
    } else redirect(MODULE);
    return "";
}

function univeral_create_tpl($file,  $array, $return=true){
global $load_tpl, $module_name;
    $id = isset($_GET['id']) ? $_GET['id'] : "";
    if (nc_file_exists("templates/{$load_tpl}/{$file}-{$module_name}-{$id}.tpl")) $file_tpl = "templates/{$load_tpl}/{$file}-{$module_name}-{$id}.tpl";
    elseif (nc_file_exists("templates/{$load_tpl}/{$file}-{$module_name}.tpl")) $file_tpl = "templates/{$load_tpl}/{$file}-{$module_name}.tpl";
    else $file_tpl = "templates/{$load_tpl}/{$file}.tpl";
    $content = nc_get_content($file_tpl);
    foreach($array as $key => $value){
        $content = str_replace('$'.$key, $value, $content);
    }
    if($return) return $content;
    else echo $content;
    return "";
}

function loads_tpl($file){
global $module_name, $load_tpl;
    if(nc_file_exists("{$file}-{$module_name}.tpl")) $tpl_file = "{$file}-{$module_name}.tpl";
    else $tpl_file = "{$file}.tpl";
    return str_replace('$load_tpl', $load_tpl, nc_get_content($tpl_file));
}

$tpl_main = new tpl_main;
?>
