<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

if (!defined("NOVACMS") AND !defined("ADMIN_FILE")) die("Access is limited");

/**
* Synonym file_exists function
* 
* @param string $file
* @return bool
*/
function nc_file_exists($file){
    return file_exists($file);
}

/**
* Synonym function rename
* 
* @param string $path
* @param string $name
* @return bool
*/
function nc_rename($path, $name){
    if(nc_file_exists($path)) return rename($path, $name);
    else return false;
}

/**
* Synonym unlink function
* 
* @param string $file
* @return bool
*/
function nc_unlink($file){
    if(nc_file_exists($file)) return @unlink($file);
    else return false;
}

/**
* A synonym for function file_get_contents
* 
* @param string $file
* @return string
*/
function nc_get_content($file){
    if(nc_file_exists($file)) return file_get_contents($file);
    return "";
}

/**
* Synonym function mkdir
* 
* @param string $dir
* @param int $chmod
* @return bool
*/
function nc_mkdir($dir, $chmod=777){
global $func_conf;
    if(!nc_file_exists($dir)){
        if($func_conf['chmod_mk_dir']==true) return mkdir($dir, ($chmod[0]!=0)?'0'.$chmod:$chmod);
        else return mkdir($dir);
    } else return true;
}

/**
* Synonym for copy function
* 
* @param string $source
* @param string $dest
* @return bool
*/
function nc_copy($source, $dest){
    return copy($source, $dest);
}

/**
* Synonym functions opendir
* 
* @param string $path
* @return resource
*/
function nc_opendir($path){
    return opendir($path);
}

/**
* Synonym function is_dir
* 
* @param string $file
* @return bool
*/
function nc_is_dir($file){
    if($file=='./..') return true;
    return is_dir($file);
}

/**
* Synonym function is_file
* 
* @param mixed $file
* @return bool
*/
function nc_is_file($file){
    return is_file($file);
}

/**
* Synonym function filesize
* 
* @param string $file
* @return int
*/
function nc_filesize($file){
    return filesize($file);
}

/**
* Function finds the last occurrence of char in a string.
* 
* @param string $str
* @param string $needle
* @param int $offset
* @return int
*/
function nc_strrpos($str, $needle, $offset = null){
global $is_mb_string_used;
    if(empty($str)) return $str;
    if($is_mb_string_used==true) return mb_strrpos($str, $needle, $offset);
    else return strrpos($str, $needle, $offset);
}

/**
* Function finds the position of first occurrence of the string.
* 
* @param string $str
* @param string $needle
* @param int $offset
* @return int
*/
function nc_strpos($str, $needle, $offset = null){
global $is_mb_string_used;
    if($is_mb_string_used==true) return mb_strpos($str, $needle, $offset);
    else return strpos($str, $needle, $offset);
}

/**
* The function takes the string to lowercase.
* 
* @param string $string
* @return string
*/
function nc_strtolower($string){
global $is_mb_string_used;
    if($is_mb_string_used==true) return mb_strtolower($string);
    else return strtolower($string);
}

/**
* Funaki takes the string to uppercase.
* 
* @param string $string
* @return string
*/
function nc_strtoupper($string){
global $is_mb_string_used;
    if($is_mb_string_used==true) return mb_strtoupper($string);
    else return strtoupper($string);
}

/**
* The function returns the string.
* 
* @param string $str
* @param int $offset
* @param int $length
* @return string
*/
function nc_substr($str, $offset, $length = NULL){
global $is_mb_string_used;
if(!isset($length)) $length=strlen($str)-$offset;
    if($is_mb_string_used==true) return mb_substr($str, $offset, $length);
    else return substr($str, $offset, $length);
}

/**
* Function gets the string length.
* 
* @param string $string
* @return int
*/
function nc_strlen($string){
global $is_mb_string_used;
    if($is_mb_string_used==true) return mb_strlen($string);
    else return strlen($string);
}

/**
* The function counts the number of occurrences of a substring in a string
* 
* @param string $haystack
* @param string $needle
* @param string $encoding
* @return int
*/
function nc_substr_count($haystack, $needle, $encoding = null){
global $is_mb_string_used;
    if($is_mb_string_used==true) return mb_substr_count($haystack, $needle, $encoding);
    else return substr_count($haystack, $needle);
}
?>