/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */


(function($){$.extend($, {
    DRAG:{
        onmousemove:function(){},
        onmousedown:function(){},
        onmouseup:function(){},
        ondragend:function(){},
        ondragstart:function(){},
        
        init:function(p){
            defP = {dragObject:'', moveObject:'', cursorMove:true, moveType:{x:true, y:true}}
            for (var i in defP) if(!p[i]) p[i] = defP[i];
            var drag = $$(p.dragObject);
            var move = $$(p.moveObject);
            NC_AJAX.set.style({position:'absolute'}, move);
            drag.onmousedown = function(e){
                $.DRAG.onmousedown(p.moveObject);
                $.DRAG.ondragstart(p.moveObject);
                document.ondragstart = document.body.onselectstart = function() {return false}
                if(p.cursorMove==true) NC_AJAX.set.style({cursor:'move'}, drag);
                e = $.DRAG.event(e);
                var pos = $.getPosition(this);
                var mouseOffset = {x:e.pageX-pos.x, y:e.pageY-pos.y}
                document.onmousemove = function(e) {
                    $.DRAG.onmousemove(p.moveObject);
                    $.DRAG.nosel(p.moveObject);
                    e = $.DRAG.event(e);
                    if(p.moveType.x == true) move.style.left = e.pageX-mouseOffset.x+'px';
                    if(p.moveType.y == true) move.style.top = e.pageY-mouseOffset.y+'px';
                }
            }
            drag.onmouseup = function(){
                $.DRAG.resize.update(p.moveObject);
                $.DRAG.ondragend(p.moveObject);
                $.DRAG.onmouseup(p.moveObject);
                $.DRAG.dragObject = document.ondragstart = document.body.onselectstart = document.onmousemove = null;
                if(p.cursorMove==true) NC_AJAX.set.style({cursor:''}, drag);
            }
        },
        
        nosel:function(e){
            if(!$$('no_select'+e)) var e = NC_AJAX.create.element('input', {id:'no_select'+e}, {'display':'none'}); else var e = $$('no_select'+e);
            try {e.focus()} catch(e) {}
        },

        resize:{
            resizeObj:[],
            
            init:function(t, dragObject){
                NC_AJAX.addEvent(window, 'load', function(){
                    $.DRAG.resize.resizeObj[$.DRAG.resize.resizeObj.length] = {t:t, d:dragObject};
                    $.DRAG.resize.resizeObj[$.DRAG.resize.resizeObj.length] = {t:t, d:dragObject};
                    var resize = $$(dragObject);
                    var omd = function(e){
                        document.ondragstart = document.body.onselectstart = function(){return false}
                        el = this; e = $.DRAG.event(e);
                        var s = {p:$.getPosition(resize), w:parseInt(resize.style.width), h:parseInt(resize.style.height), cb:document.body.style.cursor, c:el.style.cursor, o:{x:e.pageX, y:e.pageY}};
                        document.body.style.cursor = s.c;
                        document.onmousemove = function(e){
                            e = $.DRAG.event(e); $.DRAG.nosel(el);
                            if(s.c=='e-resize') NC_AJAX.set.style({width:(s.w+(e.pageX-s.o.x))+'px'}, resize);
                            else if(s.c=='w-resize') NC_AJAX.set.style({width:(s.w-(e.pageX-s.o.x))+'px', left:(s.p.x+(e.pageX-s.o.x))+'px'}, resize);
                            else if(s.c=='s-resize') NC_AJAX.set.style({height:(s.h+(e.pageY-s.o.y))+'px'}, resize);
                            else if(s.c=='n-resize') NC_AJAX.set.style({height:(s.h-(e.pageY-s.o.y))+'px', top:(s.p.y+(e.pageY-s.o.y))+'px'}, resize);
                            else NC_AJAX.set.style({width:(s.w+(e.pageX-s.o.x))+'px', height:(s.h+(e.pageY-s.o.y))+'px'}, resize);
                        }
                        document.onmouseup = function(e){
                            $.DRAG.resize.update(resize.id);
                            document.onmousemove = document.onmouseup = document.ondragstart = document.body.onselectstart = null;
                            document.body.style.cursor = s.cb;
                        }
                    }
                    o = $$(dragObject);
                    var info = {p:$.getPosition(o), w:o.offsetWidth, h:o.offsetHeight};
                    if(t.indexOf('right')!=-1) NC_AJAX.create.element('div', {onmousedown:omd, className:'bor', id:('res_right'+'_'+dragObject), innerHTML:'<img src="includes/images/pixel.gif" alt="" />'}, {display:'block', cursor:'e-resize', left:(info.p.x+info.w-3)+'px', top:(info.p.y+2)+'px', width:3+'px', height:(info.h-6)+'px', position:'absolute', zIndex:95});
                    if(t.indexOf('left')!=-1) NC_AJAX.create.element('div', {onmousedown:omd, className:'bor', id:('res_left'+'_'+dragObject), innerHTML:'<img src="includes/images/pixel.gif" alt="" />'}, {display:'block', cursor:'w-resize', left:(info.p.x-2)+'px', top:(info.p.y+2)+'px', width:3+'px', height:(info.h-6)+'px', position:'absolute', zIndex:95});
                    if(t.indexOf('top')!=-1) NC_AJAX.create.element('div', {onmousedown:omd, className:'bor', id:('res_top'+'_'+dragObject), innerHTML:'<img src="includes/images/pixel.gif" alt="" />'}, {display:'block', cursor:'n-resize', left:(info.p.x-2)+'px', top:(info.p.y-2)+'px', width:(info.w+2)+'px', height:3+'px', position:'absolute', zIndex:95});
                    if(t.indexOf('bottom')!=-1) NC_AJAX.create.element('div', {onmousedown:omd, className:'bor', id:('res_bottom'+'_'+dragObject), innerHTML:'<img src="includes/images/pixel.gif" alt="" />'}, {display:'block', cursor:'s-resize', left:(info.p.x-2)+'px', top:(info.p.y+info.h-3)+'px', width:(info.w+2)+'px', height:3+'px', position:'absolute', zIndex:95});
                    if(t.indexOf('resize')!=-1) NC_AJAX.create.element('div', {onmousedown:omd, className:'bor2', id:('res_resize'+'_'+dragObject), innerHTML:'<img src="includes/images/pixel.gif" alt="" />'}, {display:'block', cursor:'se-resize', left:(info.p.x+info.w-7)+'px', top:(info.p.y+info.h-7)+'px', width:5+'px', height:5+'px', position:'absolute', zIndex:96});
                });
            },

            update:function(obj){
                t = '';
                for(var i=0;i<$.DRAG.resize.resizeObj.length;i++){
                    if($.DRAG.resize.resizeObj[i].d==obj){
                        t = $.DRAG.resize.resizeObj[i].t;
                        break;
                    }
                }
                var e = $$(obj);
                var info = {p:$.getPosition(e), w:e.offsetWidth, h:e.offsetHeight};
                if(t.indexOf('right')!=-1) $.set.style({left:(info.p.x+info.w-3)+'px', top:(info.p.y+2)+'px', width:3+'px', height:(info.h-6)+'px'}, $$('res_right'+'_'+obj));
                if(t.indexOf('left')!=-1) $.set.style({left:(info.p.x-2)+'px', top:(info.p.y+2)+'px', width:3+'px', height:(info.h-6)+'px'}, $$('res_left'+'_'+obj));
                if(t.indexOf('top')!=-1) $.set.style({left:(info.p.x-2)+'px', top:(info.p.y-2)+'px', width:(info.w+2)+'px', height:3+'px'}, $$('res_top'+'_'+obj));
                if(t.indexOf('bottom')!=-1) $.set.style({left:(info.p.x-2)+'px', top:(info.p.y+info.h-3)+'px', width:(info.w+2)+'px', height:3+'px'}, $$('res_bottom'+'_'+obj));
                if(t.indexOf('resize')!=-1) $.set.style({left:(info.p.x+info.w-7)+'px', top:(info.p.y+info.h-7)+'px', width:5+'px', height:5+'px'}, $$('res_resize'+'_'+obj));
            }
        },

        event:function(e) {
            e = e || window.event;
            if(e.pageX == null && e.clientX != null){
                var html = document.documentElement;
                var body = document.body;
                e.pageX = e.clientX + (html && html.scrollLeft || body && body.scrollLeft || 0) - (html.clientLeft || 0);
                e.pageY = e.clientY + (html && html.scrollTop || body && body.scrollTop || 0) - (html.clientTop || 0);
            } 
            if(!e.which && e.button) e.which = e.button & 1 ? 1 : (e.button & 2 ? 3 : (e.button & 4 ? 2 : 0));
            return e;
        }
    }
})
})(NC_AJAX)