/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

var loaded = 0;
(function($){$.extend($, {
    sound:{
        e:{},
        sounds:[],
        thisSound: null,
        emptyTime: '-:--',
        isReady:false,
        updatePlayng:'index.php?module=audio&do=update_playng',

        init:function(){
            $.include.script('includes/javascript/soundmanager/soundmanager.js', function(){
                var defaultOptions = {autoLoad:false, autoPlay:false, multiShot:true, debugMode:false, consoleOnly:false}
                for (var i in defaultOptions) soundManager[i] = defaultOptions[i];
                soundManager.url = 'includes/javascript/soundmanager/';
                setTimeout(function(){soundManager.onready(function(){NC_AJAX.sound.isReady = true;});}, 100);
            });            
        },
        
        creacte_audio:function(e){
            if(NC_AJAX.sound.isReady == true){
                for(var i in e) {soundManager.createSound({
                    id:i,
                    url:'uploads/audio/record/'+e[i],
                    onplay:$.sound.event.play,
                    onstop:$.sound.event.stop,
                    onpause:$.sound.event.pause,
                    onresume:$.sound.event.resume,
                    onfinish:$.sound.event.finish,
                    whileloading:$.sound.event.whileloading,
                    whileplaying:$.sound.event.whileplaying,
                    onmetadata:$.sound.event.metadata,
                    onload:$.sound.event.onload
                });}                 
            } else setTimeout(function(){NC_AJAX.sound.creacte_audio(e)}, 100);
        },

        addAudio:function(e){
            for(var i in e) {$.sound.e[i] = {}; $.sound.sounds[$.sound.sounds.length] = i;}            
            $.addEvent(window, 'load', function(){NC_AJAX.sound.creacte_audio(e)});
        },

        play:function(e){
            if(NC_AJAX.sound.isReady==true){                
                this.stopAll(e);
                if(this.thisSound!=e) {
                    haja({action:$.sound.updatePlayng, animation:false}, {'file':e}, {});
                    $$('time_'+e).innerHTML = this.emptyTime+' / '+this.emptyTime;
                }
                $$('track_'+e).innerHTML = $.sound.getTrackLine(e);
                soundManager.play(this.thisSound = e);
            } else setTimeout(function(){NC_AJAX.sound.play(e)}, 100);
        },

        stop:function(e){soundManager.stop(e);},
        pause:function(e){soundManager.pause(e);},
        stopAll:function(e){for (var i in $.sound.e) {(e!=i)?this.stop(i):this.pause(i); $$('play_button_'+i).className = 'play'; if(e!=i){ $$('time_'+i).innerHTML = ''; $$('track_'+i).innerHTML = '<div class="lineDod"></div>';}}},
        getTrackLine:function(e){return "<div class='setPosition'><div class='trackLine'><div class='trackLoading' style='width: "+loaded+"%;'><div class='trackPosition' style='width:"+(($.sound.e[e].position*100/$.sound.e[e].duration).toFixed(0))+"%;'></div></div></div></div>";},
        
        getTime:function(msec){
            var ms = Math.floor(msec/1000);
            var s = ms-(Math.floor(ms/60)*60);
            return Math.floor(ms/60)+':'+(s<10?'0'+s:s);
        },

        playTrack:function(e, button){
            if(button.className=='play'){$.sound.play(e); button.className='pause';} else {$.sound.pause(e); button.className='play';}
            button.onclick = function(){$.sound.playTrack(e, button, button.className=='play'?'pause':'play');}
        },

        createPlayList:function(e){            
            var html = "<table width='100%' class='sound' cellspacing='3' cellpadding='3'>";
            for (var i in $.sound.e) if($$(i)) html += "<tr><td rowspan='2' width='30' align='center'><img id='play_button_"+i+"' onclick=\"NC_AJAX.sound.playTrack('"+i+"', this);\" src='includes/images/pixel.gif' alt='' class='play' /></td><td>"+(($$(i)) ? $$(i).innerHTML : 'undefined')+"</td><td id='time_"+i+"' align='right' width='100' class='timeTrack'></td></tr><tr><td id='track_"+i+"' colspan='2'><div class='lineDod'></div></td></tr>";
            $$(e).innerHTML = html+"</table>";
        },

        nextPlay:function(e){
            if($.sound.sounds.length>1){
                var nP, n = false, j=0;
                for (var i in $.sound.e){
                    if(j==0 || n==true) nP = i;
                    n = (i==e && n!=true)?true:false;
                    j++;
                }
                this.playTrack(nP, $$('play_button_'+nP));
            }
        },

        event:{
            play:null,
            stop:null,
            pause:null,
            finish:function(){$.sound.nextPlay(this.sID);},
            whileloading:function(){loaded = (this.bytesLoaded*100/this.bytesTotal).toFixed(0);},
            whileplaying:function(){
                $.sound.e[this.sID] = {position: this.position, duration: this.durationEstimate, leftTime: $.sound.getTime(this.position), totalTime: $.sound.getTime(this.durationEstimate)};
                $$('time_'+this.sID).innerHTML = $.sound.e[this.sID].leftTime+' / '+$.sound.e[this.sID].totalTime;
                $$('track_'+this.sID).innerHTML = $.sound.getTrackLine(this.sID);
            },
            metadata:null,
            onload:null
        }
    }
})
})(NC_AJAX)
NC_AJAX.sound.init();