<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

define ("MOD_TITLE", FALSE); //modify the title information on compression and other things
define ("GETURL", "urlx"); //GET-name parameter, which is url
 
function getStrMas($_MAS, $MAS_STR){
    $MAS_STR="";
    foreach($_MAS as $key => $value){
        //if included magic_quotes, then do "unMagic_quotes"
        if(get_magic_quotes_gpc()) $value=stripslashes($value);
        $MAS_STR.='&'.$key.'='.urlencode($value);
    }
    //remove the first '&'
    if($MAS_STR!="") $MAS_STR=substr($MAS_STR, 1);
}

/**
* Finds, cuts and processes the official title of the page received nxn proxy (on the target server).
* Under this heading is formed by the page`s title, coming from the nxn proxy browser.
* Cut the title from $ret_data.
*/

function getHeader($_ret_data){
global $no_zip, $head_sep;
    $no_zip = false; $head_sep="";
    // find the position of the separator on the title and body of the page
    // find smaller due to the fact that some servers share the title of the body \n\n
    // instead of the required \r\n\r\n (eg, http://www.mts.ru/sms, in doyaytsevuyu era)
    $classic = nc_strpos($_ret_data, "\r\n\r\n");
    $olen = nc_strpos($_ret_data, "\n\n");
    if(($classic!==FALSE) && (($olen===FALSE) || ($olen>$classic))){
        $i_head=$classic; //i_head - position of delimiter header and body of the data
        $head_mes_separator="\r\n\r\n";
    }elseif($olen!==FALSE){
        $i_head=$olen;
        $head_mes_separator="\n\n";
        $head_sep="олень"; //check the "server-deer" (shown in the title page)
    } else die ("<h1>HTTP-header error /olen/ !</h1>");
    
    //get header pages, and her body
    $header=substr($_ret_data, 0, $i_head);
    $_ret_data=substr($_ret_data, $i_head+strlen($head_mes_separator));
    //obtain an array of strings from the header-a and its insertion in the header, given up by the client browser
    $header_mas=split("\r\n", $header);
    //$fout=fopen("tmp.log", "wb");
    //fwrite ($fout, "***".$header_mas[9]."***\r\n");

    //among the titles are looking for a redirect (via the location - if it is, then give this title to a client)
    while (current ($header_mas)){
        $headline=$header_mas[key($header_mas)];
       //here, more and earlier, some operations can be performed by Regulus. expression
       //fwrite ($fout, "***".$headline."***\r\n");
       //header ($headline);
       //catch already compressed pages so as not to pinch them twice
       if ((findHeaderLine ( "Content-Encoding", $headline)==1) AND (nc_strpos(strtolower($headline), 'gzip')!=FALSE)) $no_zip=true;
       elseif((findHeaderLine ( "Content-Type", $headline)==1) AND
             ((nc_strpos(strtolower($headline), 'image/jpeg')!=FALSE) OR //done for the sake of IE5, because Opera 7.51 simply "eat " zipovany jpeg and png
             (nc_strpos(strtolower($headline), 'image/png')!=FALSE))) $no_zip=true; 
       if (findHeaderLine ( "Transfer-Encoding", $headline)!=1) header ($headline);
       next($header_mas);
    }
    // fclose ($fout);
}

/**
*  Checks a string from the header for the presence of her substring ($ template = "location" / redirect / instance)
*  if found, returns 1.
*/
function findHeaderLine ($template, $headline){
    // search for key titles - if we find
    // return 1
    $res=preg_replace($template, "", substr($headline, 0, strlen($template)));
    if($res!=substr($headline, 0, strlen($template)))  return 1; //т.е. нашли
    return -1;
}

/**
*  Returns the Unix timestamp with microseconds
*/
function getMicroTime(){
    list($msec, $sec) = explode(" ", microtime());
    return ((float)$msec + (float)$sec);
}

function convert_http_param($h_str){
    $h_tmp=strtolower($h_str);
    $h_tmp=preg_replace('(_)','_ ',$h_tmp);
    $h_tmp=ucwords($h_tmp);
    $h_tmp=preg_replace('(_ )','-',$h_tmp);
    return $h_tmp;
}

if(isset($_GET[GETURL])){
    //run the system web proxy, if you set get-parameter GETURL
    $time_start=getMicroTime();
    $POST_STR="";
    $GET_STR="";
    $COOKIE_STR="";

    //obtain the URL of the page (this option also is the first het-parameter)
    $url=$_GET[GETURL];
    $parse_url=explode('?', $url); //parse_url[0] - URL page; parse_url [1] - the first het-parameter
    //parsing the first het-setting if it exists
    if(isset($parse_url[1])) {
        $sub_parse=explode('=', $parse_url[1]);//divide in the name of GET-variable and its value
        //here, more and earlier, some operations can be performed by Regulus. expression
        if(isset($sub_parse[1])){
            //if included magic_quotes, then do "unMagic_quotes"
            if (get_magic_quotes_gpc()) $sub_parse[1]=stripslashes($sub_parse[1]);
            $url=$parse_url[0].'?'.$sub_parse[0].'='.urlencode($sub_parse[1]);
        } else $url=$parse_url[0].'?'.$sub_parse[0];
    } else $url=$parse_url[0];
    //obtain detailed parameters prompt
    $GET_STR=substr(strstr ($_SERVER["QUERY_STRING"], '&'),1);
    getStrMas($_POST, &$POST_STR);
    getStrMas($_COOKIE, &$COOKIE_STR);
    // Session Initiation CURL-a
    $ch = curl_init();
    // installation URL and other necessary parameters for the capture of the page requested from Ineta
    if ($GET_STR!="") {$GET_STR="&".$GET_STR; $params="G";}
    curl_setopt($ch, CURLOPT_URL, $url.$GET_STR);
    curl_setopt($ch, CURLOPT_HEADER, 1); //sets the parameters of CURL, in response to catch the headlines page
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 10); //CURL returns the result, rather than an output
    curl_setopt($ch, CURLOPT_MUTE, 1);
    //do redirection means CURL-and, if required
    //if CURL did not return two headers in the case of a round-trip, it would be possible razremarit
    //curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    //send post variables CURL-th
    if($POST_STR!="") {
        curl_setopt($ch, CURLOPT_POSTFIELDS, $POST_STR);
        $params.="P";
    }
    //send COOKIES CURL-th
    if($COOKIE_STR!=""){
        curl_setopt($ch, CURLOPT_COOKIE, $COOKIE_STR);
        $params.="C";
    }
    $i=0; //marks the request headers from the client browser in the CURL-http-options (skipping HOST)
    foreach($_SERVER as $h=>$v){
        if(preg_match('HTTP_(.+)', $h, $hp)){
            $adp=convert_http_param($hp[1]).": ".$v;
            if(strtolower($hp[1])=="host") $adp="";
            $sbt = strtolower(substr($hp[1],0,2));
            if($sbt=="x_") $adp="";
            $shead=$shead.$adp;
            if($adp!=""){
                $httpheaders[$i++]=convert_http_param($hp[1]).": ".$v;
                // echo $sbt."   ".convert_http_param($hp[1]).": ".$v."\r\n";
            }
            // if (strtolower($hp[1])!="host") $httpheaders[$i++]=convert_http_param($hp[1]).": ".$v;
        }
    }
    curl_setopt ($ch, CURLOPT_HTTPHEADER, $httpheaders);

    // fclose ($fout);
    //CURLOPT_HTTPHEADER
    //curl_setopt ($ch, CURLOPT_HTTPHEADER, Array("Accept-Language: ru"));
    // loading the page and giving it to the variable $ ret_data
    $ret_data=curl_exec($ch);

    //cut out the headline from ret_data and pass the appropriate (location, content-type) part of the header to the client
    getHeader (&$ret_data);
    //compress the data transferred
    if ($no_zip==false){
        $gzdata = gzencode($ret_data, 9); //compression test to determine the volume of compressed
        $inSize=strlen($ret_data); $outSize=strlen($gzdata);
        $tmp_ret_data=$ret_data; //retain the original value to the case of non-text characters in $ ret_data == binary
        //make the modified title for html
        if(MOD_TITLE) $ret_data = preg_replace( "<title>", "<title>".sprintf("[%s/%s=%5.2fx::%s::%5.2fс::%s]",$inSize, $outSize, ($inSize/$outSize), $params, (getMicroTime()-$time_start), $head_sep)." ", $ret_data);
        //verification to reduce the length of the lines after (this is possible only in case of downloading non-text file)
        //if the length decreased - restores $ ret_data existing content
        if(strlen($tmp_ret_data)>strlen($ret_data)) $ret_data=$tmp_ret_data;
        //Compression is done twice to make a title for the second compression to put extra. information
        //resulting in part on the results of the first compression
        $gzdata = gzencode($ret_data, 9);
        header("Content-Encoding: gzip");
        header("Vary: Accept-Encoding");
        header("Content-Length: ".strlen($gzdata));
        print $gzdata;
    } else {
        //Do not compress the data transferred
        //(used to jpeg and png [compressed gif all brayzery "eat", because / as a rule, redundant / just in case it is also press])
        header("Content-Length: ".strlen($ret_data));
        print $ret_data;
    }
    // disconnect and release resources
    curl_close($ch);
} else header("HTTP/1.0 404 Not Found");
?>