CREATE TABLE `{PREFIX}_acc` (
  `uid` int(11) NOT NULL default '0',
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_attach` (
  `id` int(11) NOT NULL auto_increment,
  `module` varchar(50) default NULL,
  `path` varchar(255) default NULL,
  `file` varchar(100) default NULL,
  `downloads` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_blocks` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(50) NOT NULL,
  `position` char(1) NOT NULL default 'l',
  `view` int(1) NOT NULL default '1',
  `active` int(1) NOT NULL default '1',
  `blockfile` varchar(255) NOT NULL default '',
  `modules` text,
  `weight` int(11) NOT NULL default '0',
  `content` text,
  `language` varchar(50) default NULL,
  PRIMARY KEY  (`id`),
  KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

INSERT INTO `{PREFIX}_blocks` VALUES
(1, 'منو', 'l', 1, 1, 'block-modules.php', '', 1, '', ''),
(2, 'مدیریت', 'l', 4, 1, 'block-monitoring.php', '', 2, '', ''),
(3, 'تقویم', 'r', 1, 1, 'block-calendar.php', '', 2, '', ''),
(4, 'اطلاعات کاربری', 'r', 1, 1, 'block-user_menu.php', '', 1, '', ''),
(5, 'نظرسنجی', 'r', 1, 1, 'block-last_voting.php', '', 3, '', '');

CREATE TABLE `{PREFIX}_calendar` (
  `cid` int(11) NOT NULL auto_increment,
  `id` int(11) NOT NULL default '0',
  `module` varchar(50) NOT NULL default '',
  `date` date NOT NULL default '0000-00-00',
  `status` int(1) NOT NULL default '0',
  PRIMARY KEY  (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_categories` (
  `cid` int(11) NOT NULL auto_increment,
  `cat_id` varchar(50) default NULL,
  `title` varchar(100) NOT NULL default '',
  `module` varchar(255) NOT NULL default '',
  `description` text,
  `image` varchar(255) NOT NULL default '',
  `tree` varchar(60) NOT NULL,
  PRIMARY KEY  (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_comment` (
  `cid` int(11) NOT NULL auto_increment,
  `modul` varchar(60) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `name` varchar(60) NOT NULL default '',
  `ip` varchar(16) NOT NULL default '0.0.0.0',
  `comment` text NOT NULL,
  `parentid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_content` (
  `cid` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `text` text NOT NULL,
  `hits` int(11) NOT NULL default '0',
  `language` varchar(50) NOT NULL default '',
  `status` int(1) NOT NULL default '0',
  PRIMARY KEY  (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_favorite` (
  `id` int(11) NOT NULL auto_increment,
  `post` int(11) NOT NULL,
  `users` varchar(50) NOT NULL default '',
  `modul` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_files` (
  `id` int(11) NOT NULL auto_increment,
  `files_id` varchar(100) default NULL,
  `title` varchar(100) default NULL,
  `description` text,
  `content` text,
  `author` varchar(25) default NULL,
  `email` varchar(50) default NULL,
  `url` varchar(255) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `filesize` varchar(15) NOT NULL default '',
  `version` varchar(15) NOT NULL default '',
  `homepage` varchar(100) NOT NULL default '',
  `hits` int(11) NOT NULL default '0',
  `view` int(11) default '0',
  `comment` int(11) NOT NULL default '0',
  `cid` varchar(255) NOT NULL default '',
  `language` varchar(25) default '',
  `show_comment` int(1) NOT NULL default '1',
  `show_group` varchar(255) default '',
  `status` int(1) NOT NULL default '0',
  `rating` float(5,2) NOT NULL default '0.00',
  `voted` int(11) NOT NULL default '0',
  `tags` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_forum_reports` (
  `id` int(11) NOT NULL auto_increment,
  `post_id` int(11) default '0',
  `user_id` int(11) default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_forum_categories` (
  `cat_id` mediumint(8) unsigned NOT NULL auto_increment,
  `cat_title` varchar(100) default NULL,
  `cat_sort` int(8) NOT NULL default '0',
  PRIMARY KEY  (`cat_id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};


CREATE TABLE `{PREFIX}_forum_forums` (
  `forum_id` int(5) NOT NULL auto_increment,
  `cat_id` mediumint(8) unsigned NOT NULL default '0',
  `forum_name` varchar(150) default NULL,
  `forum_desc` text,
  `forum_status` tinyint(4) NOT NULL default '0',
  `forum_posts` mediumint(8) unsigned NOT NULL default '0',
  `forum_topics` mediumint(8) unsigned NOT NULL default '0',
  `forum_last_post_id` mediumint(8) unsigned NOT NULL default '0',
  `acc_view` int(1) NOT NULL default '0',
  `acc_write` int(1) NOT NULL default '0',
  `acc_post` int(1) NOT NULL default '0',
  `acc_edit` int(1) NOT NULL default '2',
  `acc_delete` int(1) NOT NULL default '2',
  `pos` int(11) NOT NULL default '0',
  PRIMARY KEY  (`forum_id`),
  KEY `cat_id` (`cat_id`),
  KEY `forum_last_post_id` (`forum_last_post_id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_forum_posts` (
  `post_id` mediumint(8) unsigned NOT NULL auto_increment,
  `topic_id` mediumint(8) unsigned NOT NULL default '0',
  `forum_id` smallint(5) unsigned NOT NULL default '0',
  `poster_id` mediumint(8) NOT NULL default '0',
  `post_time` int(11) NOT NULL default '0',
  `poster_ip` varchar(15) default NULL,
  `post_edit_time` int(11) default NULL,
  `post_subject` varchar(150) default NULL,
  `post_text` text,
  `poster_name` varchar(50) default NULL,
  `ico` varchar(50) default NULL,
  `post_tnx` text,
  `post_edit_user` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`post_id`),
  KEY `forum_id` (`forum_id`),
  KEY `topic_id` (`topic_id`),
  KEY `poster_id` (`poster_id`),
  KEY `post_time` (`post_time`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_forum_search` (
  `id` int(11) NOT NULL auto_increment,
  `key` varchar(32) default NULL,
  `topic_id` int(11) NOT NULL default '0',
  `time` varchar(16) default NULL,
  `keywords` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_forum_search_keys` (
  `id` int(11) NOT NULL auto_increment,
  `key` varchar(32) default NULL,
  `query` text,
  `ignore` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_forum_topics` (
  `topic_id` mediumint(8) unsigned NOT NULL auto_increment,
  `forum_id` smallint(8) unsigned NOT NULL default '0',
  `topic_title` varchar(60) NOT NULL default '',
  `topic_desc` varchar(255) NOT NULL default '',
  `topic_poster` mediumint(8) NOT NULL default '0',
  `topic_time` int(11) NOT NULL default '0',
  `topic_views` mediumint(8) unsigned NOT NULL default '0',
  `topic_replies` mediumint(8) unsigned NOT NULL default '0',
  `topic_status` tinyint(3) NOT NULL default '0',
  `topic_type` int(1) default '0',
  `topic_first_post_id` mediumint(8) unsigned NOT NULL default '0',
  `topic_last_post_id` mediumint(8) unsigned NOT NULL default '0',
  `topic_poster_name` varchar(50) NOT NULL default '',
  `ico` varchar(20) default NULL,
  PRIMARY KEY  (`topic_id`),
  KEY `forum_id` (`forum_id`),
  KEY `topic_status` (`topic_status`),
  KEY `topic_type` (`topic_type`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_groups` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `description` text,
  `special` int(1) NOT NULL default '0',
  `color` varchar(7) NOT NULL default '',
  `points` int(11) NOT NULL default '0',
  `img` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

INSERT INTO `{PREFIX}_groups` VALUES
(1, 'مدیریت سایت', 'مدیریت سایت', 1, 'dd0000', 0, 'admin.png'),
(2, 'مدیر', 'مدیر', 1, '2ba94f', 0, 'moderators.png'),
(3, 'موتور جستجو', 'موتور جستجو (بات)', 1, '000000', 0, ''),
(4, 'مهمان', 'بازدید کنندگان سایت', 1, '660000', 0, 'guestspng.png'),
(5, 'کاربر', 'کاربران سایت', 0, '0066cc', 5, 'users.png');

CREATE TABLE `{PREFIX}_menu` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(50) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `groups` varchar(100) default NULL,
  `class` varchar(15) default NULL,
  `pos` int(3) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_message` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(50) default NULL,
  `content` text,
  `status` int(1) NOT NULL default '0',
  `groups` varchar(255) NOT NULL default '',
  `pos` int(3) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_modules` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(50) default NULL,
  `module` varchar(50) NOT NULL,
  `active` int(1) NOT NULL default '0',
  `view` int(1) NOT NULL default '0',
  `blocks` int(1) NOT NULL default '0',
  `groups` varchar(255) default NULL,
  `pos` int(3) NOT NULL default '0',
  `sitemap` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

INSERT INTO `{PREFIX}_modules` VALUES
(1, 'صفحه شخصی', 'account', 1, 1, 1, '', 1, ''),
(2, 'انجمن گفتگو', 'forum', 1, 1, 3, '', 2, ''),
(3, 'اخبار', 'news', 1, 1, 0, '', 3, ''),
(4, 'صفحات', 'pages', 1, 1, 0, '', 4, ''),
(5, 'دانلود', 'files', 1, 1, 0, '', 5, ''),
(6, 'فروشگاه', 'shop', 1, 1, 0, '', 9, ''),
(7, 'جستجو', 'search', 1, 1, 0, '', 10, ''),
(9, 'نظرسنجی', 'voting', 1, 1, 0, '', 12, ''),
(10, 'برترین سایت ها', 'top_site', 1, 1, 1, '', 16, ''),
(11, 'برترین کاربران', 'top_users', 1, 1, 1, '', 17, ''),
(12, 'معرفی به دوستان', 'recommend', 1, 1, 0, '', 18, ''),
(13, 'تماس با ما', 'contact', 1, 1, 0, '', 19, ''),
(14, 'صفحات ثابت', 'static', 1, 1, 0, '', 8, '');

CREATE TABLE `{PREFIX}_news` (
  `id` int(11) NOT NULL auto_increment,
  `news_id` varchar(255) default NULL,
  `title` varchar(100) default NULL,
  `begin` text,
  `content` text,
  `author` varchar(25) default NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `view` int(11) NOT NULL default '0',
  `comment` int(11) NOT NULL default '0',
  `cid` varchar(255) NOT NULL default '',
  `language` varchar(25) default '',
  `show_comment` int(1) NOT NULL default '1',
  `show_group` varchar(255) NOT NULL,
  `status` int(1) NOT NULL default '0',
  `rating` float(5,2) NOT NULL default '0.00',
  `voted` int(11) NOT NULL default '0',
  `tags` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_pages` (
  `id` int(11) NOT NULL auto_increment,
  `pages_id` varchar(255) default NULL,
  `title` varchar(100) default NULL,
  `begin` text,
  `content` text,
  `author` varchar(25) default NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `view` int(11) NOT NULL default '0',
  `comment` int(11) NOT NULL default '0',
  `cid` varchar(255) NOT NULL default '',
  `status` int(1) NOT NULL default '0',
  `language` varchar(25) default '',
  `show_comment` int(1) NOT NULL default '1',
  `show_group` varchar(255) NOT NULL,
  `rating` float(5,2) NOT NULL default '0.00',
  `voted` int(11) NOT NULL default '0',
  `tags` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_pm` (
  `mid` int(11) unsigned NOT NULL auto_increment,
  `tid` int(11) NOT NULL default '0',
  `subj` varchar(255) NOT NULL default '',
  `user` varchar(50) NOT NULL default '',
  `user_from` varchar(50) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `pm_read` int(1) NOT NULL default '0',
  `status` int(1) NOT NULL default '0',
  `type` int(1) NOT NULL default '0',
  PRIMARY KEY  (`mid`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_pm_text` (
  `tid` int(11) NOT NULL auto_increment,
  `text` text NOT NULL,
  PRIMARY KEY  (`tid`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_robot` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default '',
  `visit` datetime NOT NULL default '0000-00-00 00:00:00',
  `country` varchar(50) NOT NULL default 'default',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_search` (
  `id` int(11) NOT NULL auto_increment,
  `key` varchar(32) default NULL,
  `title` varchar(150) default NULL,
  `author` varchar(50) default NULL,
  `content` text,
  `date` datetime NOT NULL COMMENT '0000-00-00 00:00:00',
  `module` varchar(25) default NULL,
  `subid` int(11) NOT NULL default '0',
  `rewrite_id` varchar(50) default NULL,
  `time` varchar(16) default NULL,
  `keywords` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_search_keys` (
  `id` int(11) NOT NULL auto_increment,
  `key` varchar(32) default NULL,
  `query` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_sessions` (
  `sid` varchar(100) NOT NULL default '',
  `uname` varchar(25) default NULL,
  `is_admin` int(1) NOT NULL default '0',
  `ip` varchar(15) default NULL,
  `time` varchar(14) NOT NULL default '0',
  `module` varchar(20) default NULL,
  `url` varchar(255) default NULL,
  `user_agent` varchar(255) default NULL,
  `country` varchar(50) NOT NULL default 'default',
  PRIMARY KEY  (`sid`),
  UNIQUE KEY `uname` (`uname`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_shop` (
  `id` int(11) NOT NULL auto_increment,
  `shop_id` varchar(100) default NULL,
  `title` varchar(100) default NULL,
  `author` varchar(25) default NULL,
  `description` text,
  `content` text,
  `pay` float(11,2) NOT NULL default '0.00',
  `img` varchar(255) default NULL,
  `cid` varchar(255) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `clients` int(11) NOT NULL default '0',
  `view` int(11) NOT NULL default '0',
  `comment` int(11) NOT NULL default '0',
  `status` int(1) NOT NULL default '0',
  `show_comment` int(1) NOT NULL default '1',
  `language` varchar(25) default '',
  `rating` float(5,2) NOT NULL default '0.00',
  `voted` int(11) NOT NULL default '0',
  `advanced` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_shop_clients` (
  `sid` int(11) NOT NULL auto_increment,
  `date` date NOT NULL default '0000-00-00',
  `form` text NOT NULL,
  `pay` float(11,2) NOT NULL default '0.00',
  `comment` text,
  `unique_id` varchar(30) default NULL,
  `status` int(1) default '0',
  `user` int(11) default '-1',
  PRIMARY KEY  (`sid`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_static` (
  `id` int(11) NOT NULL auto_increment,
  `static_id` varchar(255) default NULL,
  `title` varchar(255) default NULL,
  `content` longtext,
  `template` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_tags` (
  `id` int(11) NOT NULL auto_increment,
  `post` int(11) NOT NULL,
  `tag` varchar(100) NOT NULL default '',
  `modul` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_topsites` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(100) default NULL,
  `link` varchar(50) default NULL,
  `mail` varchar(255) NOT NULL default '',
  `img` varchar(50) default NULL,
  `description` text,
  `date` date NOT NULL default '0000-00-00',
  `hits_out` int(11) NOT NULL default '0',
  `hits_in` int(11) NOT NULL default '0',
  `hosts` longtext,
  `status` int(1) NOT NULL default '0',
  `rating` float(5,2) NOT NULL default '0.00',
  `voted` int(11) NOT NULL default '0',
  `language` varchar(25) default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

CREATE TABLE `{PREFIX}_users` (
  `uid` int(11) NOT NULL auto_increment,
  `user_id` varchar(50) NOT NULL default '',
  `user_name` varchar(25) NOT NULL default '',
  `user_email` varchar(255) default NULL,
  `user_website` varchar(255) NOT NULL default 'http://',
  `user_avatar` varchar(100) NOT NULL default 'default.png',
  `user_regdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `user_country` varchar(50) NOT NULL default 'default',
  `user_level` int(1) NOT NULL default '0',
  `user_icq` varchar(15) default NULL,
  `user_aim` varchar(18) default NULL,
  `user_yim` varchar(25) default NULL,
  `user_msnm` varchar(25) default NULL,
  `user_password` varchar(40) NOT NULL,
  `user_group` int(11) NOT NULL default '0',
  `user_groups` varchar(255) default NULL,
  `user_last_ip` varchar(15) NOT NULL default '0.0.0.0',
  `user_last_proxy` varchar(15) NOT NULL default 'N/A',
  `user_last_visit` datetime NOT NULL default '0000-00-00 00:00:00',
  `user_last_os` varchar(100) NOT NULL default 'N/A',
  `user_last_browser` varchar(100) NOT NULL default 'N/A',
  `user_birthday` date NOT NULL default '0000-00-00',
  `user_gender` int(1) NOT NULL default '0',
  `user_language` varchar(50) default NULL,
  `user_template` varchar(50) default NULL,
  `user_locality` varchar(100) default NULL,
  `user_signature` text,
  `user_interests` varchar(100) default NULL,
  `user_occupation` varchar(100) default NULL,
  `user_viewemail` int(1) NOT NULL default '0',
  `user_comments` int(5) NOT NULL default '0',
  `user_points` int(11) NOT NULL default '0',
  `user_posts` int(11) NOT NULL default '0',
  `user_timeout` int(11) NOT NULL default '0',
  `user_tnx` int(11) NOT NULL default '0',
  `user_baned` int(1) NOT NULL default '0',
  `user_baned_time` int(11) NOT NULL default '0',
  `user_baned_reason` varchar(100) default NULL,
  `user_activation` int(1) NOT NULL default '0',
  `user_activation_code` varchar(25) default NULL,
  `user_moderation` int(1) NOT NULL default '1',
  `user_password_update` int(11) NOT NULL default '0',
  `user_gmt` int(2) NOT NULL default '0',
  `rating` float(5,2) NOT NULL default '0.00',
  `voted` int(11) NOT NULL default '0',
  `user_pm_send` int(1) NOT NULL default '1',
  `user_adm_modules` tinytext,
  `user_new_pm_count` int(2) NOT NULL default '0',
  `user_new_pm_window` int(1) NOT NULL default '1',
  `user_skype` varchar(25) NOT NULL default '',
  `user_gtalk` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`uid`),
  UNIQUE KEY `uname` (`user_name`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

INSERT INTO `{PREFIX}_users` VALUES
(-1, 'guest', 'Guest', '', '', 'default.png', '0000-00-00 00:00:00', 'default', 0, '', '', '', '', '', 5, '', '0', '', '0000-00-00 00:00:00', '', '', '0000-00-00', 0, '', '', '', '', '', '', 0, -1, 0, 0, 0, 0, 0, 0, '', 0, 'MBzx97cQMjKQ47tJgil9PBQDr', 1, 0, 0, '0.00', 0, 1, NULL, 0, 1, '', '');


CREATE TABLE `{PREFIX}_voting` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `vote_case` text NOT NULL,
  `vote_ip` text,
  `vote_users` text,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `result` text,
  `comment` int(11) NOT NULL default '0',
  `status` int(1) NOT NULL default '0',
  `language` varchar(25) default NULL,
  `show_comment` int(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET={CHARSET};

INSERT INTO `{PREFIX}_voting` VALUES
(1, 'نظر شما در مورد سیستم چیست؟', 'بسیارعالی|عالی|خوب|قابل پیشرفت|بد نیست|خوب نیست|', '127.0.0.1,', 'demo,', '{DATETIME}', '1,', 0, 1, '', 1);

