<?php

/*
 * Evolution Nova
 *
 * @author       Bahram Davodi  <dev@nova-cms.com>
 * @copyright    Copyright (C) 2008-2010 All rights reserved.
 * @license      GNU/GPLv2 http://www.gnu.org/licenses/
 * @link         http://www.nova-cms.com
 *
 */

class account extends account_system {
    var $prefix = 'phpbb.phpbb_';
    
    function board_config(){
    global $main;
        $result = $main->db->sql_query("SELECT * FROM {$this->prefix}config");
        while ($row = $main->db->sql_fetchrow($result)) $board_config[$row['config_name']] = $row['config_value'];
        return $board_config;
    }
    
    function encode_ip($dotquad_ip){
        $ip_sep = explode('.', $dotquad_ip);
        return sprintf('%02x%02x%02x%02x', $ip_sep[0], $ip_sep[1], $ip_sep[2], $ip_sep[3]);
    }
    
    function login($login, $pass, $redirect=true){
    global $main;
        $board_config = $this->board_config();
        list($user_id) = $main->db->sql_fetchrow($main->db->sql_query("SELECT user_id FROM {$this->prefix}users WHERE username='{$login}'"));
        if($user_id){            
            $admin = (is_admin()) ? "1" : "0";
            $sessiondata = array('autologinid' => session_id(), 'userid' => $user_id);
            setcookie($board_config['cookie_name']."_data", serialize($sessiondata), time() + 31622400, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
            setcookie($board_config['cookie_name']."_sid", session_id(), 0, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
            $main->db->sql_query("DELETE FROM {$this->prefix}sessions_keys WHERE user_id='{$user_id}'");
            $main->db->sql_query("DELETE FROM {$this->prefix}sessions WHERE session_ip='".$this->encode_ip($main->ip)."'");            
            $main->db->sql_query("INSERT INTO {$this->prefix}sessions_keys (key_id, user_id, last_ip, last_login) VALUES ('".md5(session_id())."', '{$user_id}', '".$this->encode_ip($main->ip)."', '".time()."')");
            $main->db->sql_query("INSERT INTO {$this->prefix}sessions (session_id, session_user_id, session_start, session_time, session_ip, session_page, session_logged_in, session_admin) VALUES ('".session_id()."', '{$user_id}', '".time()."', '".time()."', '".$this->encode_ip($main->ip)."', '0', '1', '{$admin}')");            
            parent::login($login, $pass, $redirect);
        } else {            
            login($main->lang['error_login_pass2']);
        }        
    }
    
    function logout(){
    global $main;    
        $board_config = $this->board_config();
        if(!isset($_COOKIE[$board_config['cookie_name']."data"]) OR !isset($_COOKIE[$board_config['cookie_name']."data"])) {
            parent::logout();
        } else {
            $session_id = isset($_COOKIE[$board_config['cookie_name']."sid"]) ? $_COOKIE[$board_config['cookie_name']."sid"] : '';
            list($user_id) = $main->db->sql_fetchrow($main->db->sql_query("SELECT user_id FROM {$this->prefix}users WHERE username='{$main->user['user_name']}'"));
            $main->db->sql_query("DELETE FROM {$this->prefix}sessions_keys WHERE user_id ='{$user_id}'");
            if($session_id != "") $main->db->sql_query("DELETE FROM {$this->prefix}sessions WHERE session_id = '{$session_id}'");
            setcookie($board_config['cookie_name'].'_data', '', time() - 31536000, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
            setcookie($board_config['cookie_name'].'_sid', '', time() - 31536000, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
            parent::logout();
        }
    }
    
    function newuser($user, $email, $password, $admin=false){
    global $main;
        $board_config = $this->board_config();
        $result = $main->db->sql_query("SELECT user_id FROM {$this->prefix}users WHERE LOWER(username)='".nc_strtolower($user)."' || user_email='{$email}'");
        if($main->db->sql_numrows($result)==0) {
            list($last_id) = $main->db->sql_fetchrow($main->db->sql_query("SELECT user_id FROM {$this->prefix}users ORDER by user_id DESC LIMIT 1") );
            $new_id = $last_id + 1;
            $main->db->sql_query("INSERT INTO {$this->prefix}users (user_id, username, user_regdate, user_password, user_email, user_active, user_website, user_icq, user_aim, user_yim, user_msnm, user_attachsig, user_viewemail, user_avatar_type, user_avatar) VALUES ('{$new_id}', '{$user}', '".time()."', '".md5($password)."', '{$email}', '1', '', '', '', '', '', '1', '0', '1', '../../../uploads/uploads/avatars/default.png')");
        }
        parent::newuser($user, $email, $password, $admin);
    }
    
    function new_pawssword(){
    global $main;
        $info = $main->db->sql_fetchrow($main->db->sql_query("SELECT user_name FROM ".USERS." WHERE user_activation_code='{$_POST['key']}'"));
        $main->db->sql_query("UPDATE {$this->prefix}users SET user_password='".md5($_POST['user_newpassword'])."' WHERE username = '{$info['user_name']}'");
        parent::new_pawssword();
    }
    
    function user_update(){
    global $main, $userconf;
        $main->db->sql_query("UPDATE {$this->prefix}users SET username='{$main->user['user_name']}', user_email='".nc_chenge_reg($_POST['user_email'])."', user_password='{$_POST['user_password']}', user_icq='".(isset($_POST['user_icq'])?$_POST['user_icq']:"")."', user_aim='".(isset($_POST['user_aim'])?$_POST['user_aim']:"")."', user_yim='".(isset($_POST['user_yim'])?$_POST['user_yim']:"")."', user_msnm='".(isset($_POST['user_msnm'])?$_POST['user_msnm']:"")."', user_website='".((isset($_POST['user_website']) AND $_POST['user_website']!='http://')?$_POST['user_website']:"")."', user_occ='".(isset($_POST['user_occupation'])?$_POST['user_occupation']:"")."', user_interests='".(isset($_POST['user_interests'])?$_POST['user_interests']:"")."', user_from='".(isset($_POST['user_locality'])?$_POST['user_locality']:"")."', user_sig='".(isset($_POST['user_signature'])?bb($_POST['user_signature']):"")."', user_avatar='../../../{$userconf['directory_avatar']}{$_POST['user_avatar']}', user_avatar_type='1', user_attachsig='1', user_viewemail='0' WHERE username = '{$main->user['user_name']}'");
        parent::user_update();
    }
    
    function delete_user($id){
    global $main;
        list($user_name) = $main->db->sql_fetchrow($main->db->sql_query("SELECT user_name FROM ".USERS." WHERE uid='{$id}'"));
        $main->db->sql_query("DELETE FROM {$this->prefix}users WHERE username ='{$user_name}'");
        parent::delete_user($id);
    }
}
?>